class AutoRecorder expands Actor config;

var() globalconfig bool bAutoActivate;
var() globalconfig string DemoNameFormat;
var() globalconfig string DemosDir;
var() globalconfig string Password;

function PostBeginPlay()
{
	local AutoRecMutator ARM;

	Super.PostBeginPlay();

	if ((Right(DemosDir, 1) != "/") && (Right(DemosDir, 1) != "\\") && (Len(DemosDir) > 0))
		DemosDir = DemosDir$"/";

	if (bAutoActivate) 
		{
		SetTimer (1, true);
		}
	else
		{
		foreach AllActors(class 'AutoRecMutator', ARM)
			{
			return;
			}

		ARM = Spawn(Class'AutoRecMutator');
		ARM.NextMutator = Level.Game.BaseMutator;
		Level.Game.BaseMutator = ARM;
        	ARM.DemosDir = DemosDir;
	        ARM.FileName = GetDemoName(DemoNameFormat);
        	ARM.Password = Password;
		}
}

function Timer()
{
	local string FileName;

	if ( GameIsPlaying() ) 
		{
		FileName = DemosDir$GetDemoName(DemoNameFormat);
		Level.ConsoleCommand("demorec \""$FileName$"\"");
		log("SUtils: Auto DemoRec started ...");
		Disable('Timer');
		}
}

function bool GameIsPlaying()
{
	local DeathMatchPlus DMP;

	if (Level.Game.IsA('DeathMatchPlus'))
	{
		DMP = DeathMatchPlus(Level.Game); 
		if (DMP.bGameEnded || (DMP.bRequireReady && (DMP.CountDown > 3)))
			return false;
	}
	return true;
}

//modified code from UsAaR33
function string GetDemoName(string format){
  local string Msg, OutMsg, cmd, MapName;
  local int pos,i, x;

  MapName = Left(string(Level), InStr(string(Level), "."));
  Msg=format;
  pos = InStr(Msg,"%");
  if (pos>-1)
  {
    While (true)
    {
      if (pos>0)
      {
        OutMsg = OutMsg$Left(Msg,pos);
        Msg = Mid(Msg,pos);
        pos = 0;
      }

      x = len(Msg);
      cmd = mid(Msg,pos,2);
      if (x-2 > 0)
        Msg = right(msg,x-2);
      else
        Msg = "";
     
      if (cmd~="%L")
      {
        OutMsg = OutMsg$MapName;
      }
      else if (cmd~="%D")
      {
        OutMsg = OutMsg$LeadingZero(level.Day);
      }
      else if (cmd~="%M")
      {
        OutMsg = OutMsg$LeadingZero(level.Month);
      }
      else if (cmd~="%Y")
      {
        OutMsg = OutMsg$level.Year;
      }
      else if (cmd~="%H")
      {
        OutMsg = OutMsg$LeadingZero(level.Hour);
      }
      else if (cmd~="%I")
      {
        OutMsg = OutMsg$LeadingZero(level.Minute);
      }
      else if (cmd~="%S")
      {
        OutMsg = OutMsg$LeadingZero(level.Second);
      }
      else if (cmd~="%N")
      {
        if (Level.Game.GameReplicationInfo!=none)
          OutMsg = OutMsg$Level.Game.GameReplicationInfo.ServerName;
      }
      else if (cmd=="%%")
        OutMsg = OutMsg$"%";
      else
      {
        OutMsg = OutMsg$cmd;
      }
      
      pos = InStr(Msg,"%");
  
      if (Pos==-1)
        break;

    }  
    if (len(msg)>0)
      OutMsg = OutMsg$Msg;

  }
  else
    OutMsg = Msg;
  Msg=OutMsg;  //reverse for simplicity.
  OutMsg="";
//illegal char parsing:
  X=Len(Msg);
  for (pos = 0; pos<X; pos++){
      //USE reads bad!
        if (InStr("\\/*?<:>\"|", Mid(Msg, pos, 1)) != -1)
          continue;
        else if (InStr(" ", Mid(Msg, pos, 1)) != -1)
          outMsg = outMsg $ "_";
        else
          outMsg = outMsg $ Mid(Msg, pos, 1);
      }
  Msg=outMsg;

  return Msg;
}


function string LeadingZero(int i)
{
	local string S;

        S=string(i);
        if (len(S)==1)
		S="0"$S;
	return S;
}


final function ReplaceText(out string Text, string Replace, string With)
{
	local int i;
	local string Input;
		
	Input = Text;
	Text = "";
	i = InStr(Input, Replace);
	while(i != -1)
	{	
		Text = Text $ Left(Input, i) $ With;
		Input = Mid(Input, i + Len(Replace));	
		i = InStr(Input, Replace);
	}
	Text = Text $ Input;
}

defaultproperties
{
    bAutoActivate=True
    DemoNameFormat="%L_%D-%M-%Y_%H-%I"
    bHidden=True
    Texture=None
}
