//=============================================================================
// Monster Match.
//=============================================================================
class MMGame extends TeamGamePlus
    config;

#exec OBJ LOAD FILE="Pack\NaliWarrior.u" PACKAGE=MMGame_v1_1
#exec OBJ LOAD FILE="Pack\MMTex.utx" PACKAGE=MMGame_v1_1

var int BlueQHealth, RedQHealth;
var Pawn BlueQ, RedQ;

function PreBeginPlay ()
{
	local MMSBServerActor MMSBSA;

	MMSBSA = Spawn(Class'MMSBServerActor');
	Super.PreBeginPlay();
	SetTimer(Level.TimeDilation,True);
}

event Timer()
{
	CheckQueens();
	Super.Timer();
}

function CheckQueens()
{
	local Pawn P;
	local bool bMustUpdateBlue, bMustUpdateRed, bHaveBlue, bHaveRed ;

//	log ("Count Queens");

	foreach AllActors (class 'Pawn', P)
	{
		if (Right((Caps(P.Class)),9)=="QUEENBLUE" && P.Health > 0)
//		if (BaseQueenBlue(P) != None && BaseQueenBlue(P).Health > 0)
		{
			bHaveBlue=True;
			BlueQ = P;
			if ( BlueQHealth != P.Health )
			{
				BlueQHealth = P.Health;
//				log ("Queen Blue has some health");
				bMustUpdateBlue = True;
			}
		}
		if (Right((Caps(P.Class)),8)=="QUEENRED" && P.Health > 0)
//		if (BaseQueenRed(P) != None && BaseQueenRed(P).Health > 0)
		{
			bHaveRed=True;
			RedQ = P;
			if ( RedQHealth != P.Health )
			{
				RedQHealth = P.Health;
//				log ("Queen Red has some health");
				bMustUpdateRed = True;
			}
		}
	}
	if ( bHaveBlue)
	{
		if ( bMustUpdateBlue )
			MMGameReplicationInfo(GameReplicationInfo).QueenHealth1 = BlueQHealth;
	}
	else
	{
		MMGameReplicationInfo(GameReplicationInfo).QueenHealth1 = 0;
	}
	if ( bHaveRed )
	{
		if ( bMustUpdateRed )
			MMGameReplicationInfo(GameReplicationInfo).QueenHealth0 = RedQHealth;
	}
	else
	{
		MMGameReplicationInfo(GameReplicationInfo).QueenHealth0 = 0;
	}
}

function PostBeginPlay()
{
	local int i;
	for (i=0;i<4;i++)
	{
		Teams[i] = Spawn(class'TeamInfo');
		Teams[i].Size = 0;
		Teams[i].Score = 0;
		Teams[i].TeamName = TeamColor[i];
		Teams[i].TeamIndex = i;
		TournamentGameReplicationInfo(GameReplicationInfo).Teams[i] = Teams[i];
	}
	
	Super.PostBeginPlay();

	if ( bRatedGame )
	{
		FriendlyFireScale = 0;
		MaxTeams = 2;
	}
}

function bool FindSpecialAttractionFor(Bot aBot)
{
	local bool bRedBot, bBlueBot;

	if ( aBot.LastAttractCheck == Level.TimeSeconds )
		return false;
	if ( aBot.Health < 20 || ( aBot.Weapon == None || ( aBot.Weapon.AIRating < 0.3 ) ))
	{
/*		if ( abot.Weapon != None )
		{
			if ( aBot.bFire == 1 )
				aBot.bFire = 0;
			if ( aBot.bAltFire == 1 )
				aBot.bAltFire = 0;
		}
*/
		return False;
	}

	if ( aBot.Enemy != None && aBot.LineOfSightTo(aBot.Enemy) )
	{
		if (!aBot.IsInState('Attacking') && FRand() > 0.5 )
		{
			aBot.bHunting=False;
			aBot.GotoState('Attacking');
			return false;
		}
		else
		{
			aBot.GotoState('Retreating');
			return False;
		}
	}
	aBot.LastAttractCheck = Level.TimeSeconds;
	bRedBot = (aBot.PlayerReplicationInfo.Team == 0);
	bBlueBot = (aBot.PlayerReplicationInfo.Team == 1);
	if (aBot.Orders == 'Attack' || (aBot.Orders == 'FreeLance' && FRand() > 0.2))
	{
		if (bRedBot)
		{
			if ( aBot.Enemy == None || ( aBot.Enemy != None && !aBot.LineOfSightTo(aBot.Enemy)))
			{
				if ( BlueQ != None && BlueQ.Health > 0)
				{
					if ( aBot.CanSee(BlueQ) )
					{
						aBot.Enemy=BlueQ;
						aBot.GotoState('Attacking');
						if ( BlueQ.Enemy == None )
						{
							BlueQ.Enemy = aBot;
							if (ScriptedPawn(BlueQ) != None)
							{
								ScriptedPawn(BlueQ).LastSeenPos = aBot.Location;
								ScriptedPawn(BlueQ).Hated=aBot;
								ScriptedPawn(BlueQ).GotoState('RangedAttack');
							}
						}
						return False;
					}
					else
					{
						aBot.bHunting = True;
						aBot.MoveTarget = aBot.FindPathToward(BlueQ);
					}
					if ( aBot.MoveTarget != None )
					{
						SetAttractionStateFor(aBot);
						return True;
					}
					else
						return false;
				}
				else
				{
					if ( RedQ.Enemy != None )
					{
						aBot.Enemy = RedQ.Enemy;
						aBot.LastSeenPos = RedQ.Enemy.Location;
						aBot.GotoState('FreeLance');
						return False;
					}
					else
						return False;
				}
			}
		}

		if (bBlueBot)
		{
			if ( aBot.Enemy == None || ( aBot.Enemy != None && !aBot.LineOfSightTo(aBot.Enemy)))
			{
				if ( RedQ != None && RedQ.Health > 0)
				{
					if (aBot.CanSee(RedQ))
					{
						aBot.Enemy=RedQ;
						aBot.GotoState('Attacking');
						if ( RedQ.Enemy == None )
						{
							RedQ.Enemy = aBot;
							if (ScriptedPawn(RedQ) != None)
							{
								ScriptedPawn(RedQ).LastSeenPos = aBot.Location;
								ScriptedPawn(RedQ).Hated=aBot;
								ScriptedPawn(RedQ).GotoState('RangedAttack');
							}
						}
						return False;
					}
					else
					{
						aBot.bHunting = True;
						aBot.MoveTarget = aBot.FindPathToward(RedQ);
					}
					if (aBot.MoveTarget != None )
					{
						SetAttractionStateFor(aBot);
						return True;
					}
					else
						return false;
				}
				else
				{
					if ( BlueQ.Enemy != None )
					{
						aBot.Enemy = BlueQ.Enemy;
						aBot.LastSeenPos = BlueQ.Enemy.Location;
						aBot.GotoState('FreeLance');
						return False;
					}
					else
						return False;
				}
			}
		}
		if (aBot.Orders == 'Defend')
		{
			if ( bBlueBot )
			{
				if ( BlueQ != None )
				{
					aBot.bHunting = False;
					aBot.OrderObject=BlueQ;
					if ( !aBot.CanSee(BlueQ) )
					{
						aBot.MoveTarget = aBot.FindPathToward(BlueQ);
						return False;
					}
				}
				else return False;
			}

			if (bRedBot)
			{
				if ( RedQ != None )
				{
					aBot.bHunting = False;
					aBot.OrderObject=RedQ;
					if ( !aBot.CanSee(RedQ) )
					{
						aBot.MoveTarget = aBot.FindPathToward(RedQ);
						return False;
					}
				}
				else return False;
			}
		}
	}
}

function Actor SetDefenseFor(Bot aBot)
{
	if ( aBot.PlayerReplicationInfo.Team == 0 )
	{
		if ( RedQ != None )
			return RedQ;
	}
	else
	if ( aBot.PlayerReplicationInfo.Team == 1 )
	{
		if ( BlueQ != None )
			return BlueQ;
	}
	else
		return aBot.FindRandomDest();
	return None;
}

function bool FindPathToFortFor(Bot aBot, Actor Dest)
{
	local MM_basequeen F;

	if ( Dest == None )
	{
		aBot.SetOrders('Freelance', None, true);
		return false;
	}
if (abot.playerreplicationinfo.team == 0)
{
	F = MM_BaseQueenred(Dest);
	if ( (F != None) && (F.NearestPath != None) )
		aBot.MoveTarget = aBot.FindPathToward(F.NearestPath);
	else
		aBot.MoveTarget = aBot.FindPathToward(Dest);

	if ( aBot.MoveTarget == None )
	{
		aBot.bStayFreelance = true;
		aBot.Orders = 'FreeLance';
		if ( aBot.bVerbose )
		return false;
	}
	else
	{
		SetAttractionStateFor(aBot);
		return true;
	}
}
if (abot.playerreplicationinfo.team == 1)
{
	F = MM_BaseQueenBlue(Dest);
	if ( (F != None) && (F.NearestPath != None) )
		aBot.MoveTarget = aBot.FindPathToward(F.NearestPath);
	else
		aBot.MoveTarget = aBot.FindPathToward(Dest);

	if ( aBot.MoveTarget == None )
	{
		aBot.bStayFreelance = true;
		aBot.Orders = 'FreeLance';
		if ( aBot.bVerbose )
		return false;
	}
	else
	{
		SetAttractionStateFor(aBot);
		return true;
	}
}
}

function Killed(pawn killer, pawn Other, name damageType)
{
Super.Killed(killer, Other, damageType);

if (Killer != None)
{
if (Killer.PlayerReplicationInfo !=None)
{
	if ( (Killer != None) && (Other.IsA('MM_BaseQueen')) )
		Teams[killer.PlayerReplicationInfo.Team].Score += 1.0;


	if ( (bOverTime || (GoalTeamScore != 0)) && (other.IsA('MM_BaseQueen') && (Teams[killer.PlayerReplicationInfo.Team].Score >= GoalTeamScore) ))
		EndGame("teamscorelimit");
	else if ( bOverTime )
		EndGame("timelimit");


	if ( (Killer != None) && (Other.IsA('MM_Fly')) )
{
if (mm_fly(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;
}
else
{
		killer.PlayerReplicationInfo.Score += mm_fly(other).scorevalue;
}
}

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Fly'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 2; 
	



	if ( (Killer != None) && (Other.IsA('MM_pupae')) )
{
if (mm_pupae(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_pupae(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Pupae'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 3; 
	
/////////////////////////////// 


	if ( (Killer != None) && (Other.IsA('MM_Manta')) )
{
if (mm_manta(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_manta(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Manta'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 3; 
	
/////////////////////////////// 


	if ( (Killer != None) && (Other.IsA('MM_GiantManta')) )
{
if (mm_Giantmanta(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_Giantmanta(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_GiantManta'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 3; 
	
/////////////////////////////// 

	if ( (Killer != None) && (Other.IsA('MM_LesserBrute')) )
{
if (mm_lesserbrute(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;
//suicide//
}
else
{
		killer.PlayerReplicationInfo.Score += mm_lesserbrute(other).scorevalue;
}
}

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_LesserBrute'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 4; 
	
/////////////////////////////// 


	if ( (Killer != None) && (Other.IsA('MM_Krall')) )
{
if (mm_krall(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_krall(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Krall'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 5; 
	
/////////////////////////////// 

	
	if ( (Killer != None) && (Other.IsA('MM_Slith')) )
{
if (mm_slith(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_slith(other).scorevalue;
}
}



	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Slith'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 5; 
	
/////////////////////////////// 


	if ( (Killer != None) && (Other.IsA('MM_Mercenary')) )
{
if (mm_mercenary(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_mercenary(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Mercenary'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 9; 
	
/////////////////////////////// 

	if ( (Killer != None) && (Other.IsA('MM_Brute')) )
{
if (mm_brute(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_brute(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Brute'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 10; 
	
/////////////////////////////// 

	if ( (Killer != None) && (Other.IsA('MM_MercenaryElite')) )
{
if (mm_mercenaryelite(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_mercenaryelite(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_MercenaryElite'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 13; 
	
/////////////////////////////// 


    if ( (Killer != None) && (Other.IsA('MM_GasBag')) )
{
if (mm_gasbag(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_gasbag(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_GasBag'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 13; 
	
/////////////////////////////// 

    if ( (Killer != None) && (Other.IsA('MM_SkaarjWarrior')) )
{
if (mm_skaarjwarrior(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_skaarjwarrior(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Skaarjwarrior'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 12; 
	
/////////////////////////////// 


    if ( (Killer != None) && (Other.IsA('MM_Behemoth')) )
{
if (mm_behemoth(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_behemoth(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Behemoth'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 17; 
	
/////////////////////////////// 


    if ( (Killer != None) && (Other.IsA('MM_SkaarjBerserker')) )
{
if (mm_skaarjberserker(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_skaarjberserker(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_SkaarjBerserker'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 22; 
	
/////////////////////////////// 


    if ( (Killer != None) && (Other.IsA('MM_WarLord')) )
{
if (mm_warlord(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_warlord(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Warlord'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 64; 
	
/////////////////////////////// 

    if ( (Killer != None) && (Other.IsA('MM_Queen')) )
{
if (mm_queen(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_queen(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Queen'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 44; 
	
/////////////////////////////// 


    if ( (Killer != None) && (Other.IsA('MM_GiantGasBag')) )
{
if (mm_giantgasbag(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_giantgasbag(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_GiantGasBag'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 33; 
	
/////////////////////////////// 






    if ( (Killer != None) && (Other.IsA('MM_AncientGuard')) )
{

		killer.PlayerReplicationInfo.Score += mm_ancientguard(other).scorevalue;

}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_AncientGuard'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 75; 
	
///////////////////////////////






    if ( (Killer != None) && (Other.IsA('MM_NaliWarrior')) )
{

		killer.PlayerReplicationInfo.Score += MM_NaliWarrior(other).scorevalue;

}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_NaliWarrior'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 0; 
	
///////////////////////////////






    if ( (Killer != None) && (Other.IsA('MM_cow')) )
{

		killer.PlayerReplicationInfo.Score += mm_cow(other).scorevalue;

}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_cow'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 0; 
	
///////////////////////////////






///////////////////////////////






    if ( (Killer != None) && (Other.IsA('MM_babycow')) )
{

		killer.PlayerReplicationInfo.Score += mm_babycow(other).scorevalue;

}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_babycow'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 0; 
	
///////////////////////////////

///////////////////////////////






    if ( (Killer != None) && (Other.IsA('MM_Rocktitan')) )
{

		killer.PlayerReplicationInfo.Score += mm_Rocktitan(other).scorevalue;

}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Rocktitan'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 0; 
	
///////////////////////////////
//Rakiayn: for the bigger monsters:///
///////////////////////////////

	if ( (Killer != None) && (Other.IsA('MM_Flybig')) )
{
if (mm_flybig(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;
}
else
{
		killer.PlayerReplicationInfo.Score += mm_flybig(other).scorevalue;
}
}

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Flybig'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 2; 
	



	if ( (Killer != None) && (Other.IsA('MM_pupaebig')) )
{
if (mm_pupaebig(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_pupaebig(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Pupaebig'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 3; 
	
/////////////////////////////// 


	if ( (Killer != None) && (Other.IsA('MM_Mantabig')) )
{
if (mm_mantabig(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_mantabig(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Mantabig'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 3; 
	
/////////////////////////////// 


	if ( (Killer != None) && (Other.IsA('MM_GiantMantabig')) )
{
if (mm_Giantmantabig(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_Giantmantabig(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_GiantMantabig'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 3; 
	
/////////////////////////////// 


	if ( (Killer != None) && (Other.IsA('MM_LesserBrutebig')) )
{
if (mm_lesserbrutebig(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;
//suicide//
}
else
{
		killer.PlayerReplicationInfo.Score += mm_lesserbrutebig(other).scorevalue;
}
}

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_LesserBrutebig'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 4; 
	
/////////////////////////////// 


	if ( (Killer != None) && (Other.IsA('MM_Kralbigl')) )
{
if (mm_krallbig(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_krallbig(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Krallbig'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 5; 
	
/////////////////////////////// 

	
	if ( (Killer != None) && (Other.IsA('MM_Slithbig')) )
{
if (mm_slith(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_slithbig(other).scorevalue;
}
}



	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Slithbig'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 5; 
	
/////////////////////////////// 


	if ( (Killer != None) && (Other.IsA('MM_Mercenarybig')) )
{
if (mm_mercenarybig(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_mercenarybig(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Mercenarybig'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 9; 
	
/////////////////////////////// 

	if ( (Killer != None) && (Other.IsA('MM_Brutebig')) )
{
if (mm_brutebig(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_brutebig(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Brutebig'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 10; 
	
/////////////////////////////// 

	if ( (Killer != None) && (Other.IsA('MM_MercenaryElitebig')) )
{
if (mm_mercenaryelitebig(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_mercenaryelitebig(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_MercenaryElitebig'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 13; 
	
/////////////////////////////// 


    if ( (Killer != None) && (Other.IsA('MM_GasBagbig')) )
{
if (mm_gasbagbig(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_gasbagbig(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_GasBagbig'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 13; 
	
/////////////////////////////// 

    if ( (Killer != None) && (Other.IsA('MM_SkaarjWarriorbig')) )
{
if (mm_skaarjwarriorbig(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_skaarjwarriorbig(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Skaarjwarriorbig'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 12; 
	
/////////////////////////////// 


    if ( (Killer != None) && (Other.IsA('MM_Behemothbig')) )
{
if (mm_behemothbig(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_behemothbig(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Behemothbig'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 17; 
	
/////////////////////////////// 


    if ( (Killer != None) && (Other.IsA('MM_SkaarjBerserkerbig')) )
{
if (mm_skaarjberserkerbig(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_skaarjberserkerbig(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_SkaarjBerserkerbig'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 22; 
	
/////////////////////////////// 


    if ( (Killer != None) && (Other.IsA('MM_WarLordbig')) )
{
if (mm_warlordbig(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_warlordbig(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Warlordbig'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 64; 
	
/////////////////////////////// 

    if ( (Killer != None) && (Other.IsA('MM_Queenbig')) )
{
if (mm_queenbig(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_queenbig(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_Queenbig'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 44; 
	
/////////////////////////////// 


    if ( (Killer != None) && (Other.IsA('MM_GiantGasBagbig')) )
{
if (mm_giantgasbagbig(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += mm_giantgasbagbig(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_GiantGasBagbig'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 33; 
	
/////////////////////////////// 


/////////////////////////////// 


    if ( (Killer != None) && (Other.IsA('MM_basequeenred')) )
{
if (mm_basequeenblue(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += MM_basequeenred(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_basequeenred'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 100; 
	
/////////////////////////////// 

/////////////////////////////// 


    if ( (Killer != None) && (Other.IsA('MM_basequeenblue')) )
{
if (mm_basequeenblue(other).bzombie)
{

		killer.PlayerReplicationInfo.Score += -1;

}
else
{
		killer.PlayerReplicationInfo.Score += MM_basequeenblue(other).scorevalue;
}
}
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('MM_basequeenblue'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 100; 
	
/////////////////////////////// 





///////////////////////////////

//////////// Rakiayn: vs players////////
	
if ((Killer != other) && (Other.IsA('Bot'))
 && (Killer != None))
	killer.PlayerReplicationInfo.Score += 9;
//suicide//
	
	if ( (Other != None) && ((Killer == other) && (other.IsA('bot'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 9; 


	
if ((Killer != Other) && (other.IsA('tournamentplayer'))
 && (Killer != none))
	killer.PlayerReplicationInfo.Score += 9;  
//suicide//

	if ( (Other != None) && ((Killer == other) && (other.IsA('tournamentplayer'))
|| (Killer == none)) )
killer.PlayerReplicationInfo.Score -= 9; 
}	
}
}

function AddDefaultInventory( pawn PlayerPawn )
{
	local Weapon weap;
	local int i;
	local inventory Inv;
	local float F;

	if ( PlayerPawn.IsA('Spectator') || (bRequireReady && (CountDown > 0)) )
		return;
	bUseTranslocator = false;

	if (PlayerPawn.PlayerReplicationInfo.Team==255)

	{
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_Monsterkicker");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_FlySpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_PupaeSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_MantaSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_GiantMantaSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_LesserBruteSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_MercenaryEliteSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_BehemothSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_SkaarjWarriorSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_GasBagSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_GiantGasBagSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_QueenSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_WarLordSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_skaarjberserkerSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_KrallSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_SlithSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_BruteSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_MercenarySpawner");

	Super.AddDefaultInventory(PlayerPawn);
	}

	if (PlayerPawn.PlayerReplicationInfo.Team==0)

	{
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_Monsterkicker_R");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_FlySpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_PupaeSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_MantaSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_GiantMantaSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_LesserBruteSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_MercenaryEliteSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_BehemothSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_SkaarjWarriorSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_GasBagSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_GiantGasBagSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_QueenSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_WarLordSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_skaarjberserkerSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_KrallSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_SlithSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_BruteSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_MercenarySpawner");

	PlayerPawn.SwitchToBestWeapon();
	}

	if (PlayerPawn.PlayerReplicationInfo.Team==1)

	{
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_Monsterkicker_B");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_FlySpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_PupaeSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_MantaSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_GiantMantaSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_LesserBruteSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_MercenaryEliteSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_BehemothSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_SkaarjWarriorSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_GasBagSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_GiantGasBagSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_QueenSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_WarLordSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_skaarjberserkerSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_KrallSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_SlithSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_BruteSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_MercenarySpawner");

	PlayerPawn.SwitchToBestWeapon();
	}

	if (PlayerPawn.PlayerReplicationInfo.Team==2)

	{

	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_Monsterkicker_G");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_FlySpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_PupaeSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_MantaSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_GiantMantaSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_LesserBruteSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_MercenaryEliteSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_BehemothSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_SkaarjWarriorSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_GasBagSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_GiantGasBagSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_QueenSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_WarLordSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_skaarjberserkerSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_KrallSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_SlithSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_BruteSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_MercenarySpawner");

	PlayerPawn.SwitchToBestWeapon();
	}

	if (PlayerPawn.PlayerReplicationInfo.Team==3)

	{

	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_Monsterkicker_Y");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_FlySpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_PupaeSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_MantaSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_GiantMantaSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_LesserBruteSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_MercenaryEliteSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_BehemothSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_SkaarjWarriorSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_GasBagSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_GiantGasBagSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_QueenSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_WarLordSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_skaarjberserkerSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_KrallSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_SlithSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_BruteSpawner");
	GiveWeapon(PlayerPawn, "MMGame_v1_1.MM_MercenarySpawner");

	PlayerPawn.SwitchToBestWeapon();
	}
}

function bool IsRelevant(actor Other) 
{
	local Mutator M;
	local bool bArenaMutator;

	for (M = BaseMutator; M != None; M = M.NextMutator)
	{
		if (M.IsA('Arena'))
			bArenaMutator = True;
	}

	if ( bArenaMutator )
	{
		if ( Other.IsA('Inventory')	&& (Inventory(Other).MyMarker != None)
						&& !Other.IsA('MMAmmos')
						&& !Other.IsA('MM_Ammo')
						&& !Other.IsA('MMPickups')
						&& !Other.IsA('MM_Pickups')
						&& !Other.IsA('TournamentHealth')
						&& !Other.IsA('ThighPads')
						&& !Other.IsA('UT_JumpBoots')
						&& !Other.IsA('UT_ShieldBelt')
						&& !Other.IsA('Seeds')
						&& !Other.IsA('SCUBAGear')
						&& !Other.IsA('JumpBoots')
						&& !Other.IsA('Health')
						&& !Other.IsA('Flare'))

////Rakiayn: determine what pickups are allowed in mm////


		{
			Inventory(Other).MyMarker.markedItem = None;
			return false;
		}
	} else {
		if ( Other.IsA('Inventory')	&& (Inventory(Other).MyMarker != None)
						&& !Other.IsA('MMAmmos')
						&& !Other.IsA('MM_Ammo')
						&& !Other.IsA('MMPickups')
						&& !Other.IsA('MM_Pickups')
						&& !Other.IsA('TournamentHealth')
						&& !Other.IsA('ThighPads')
						&& !Other.IsA('UT_JumpBoots')
						&& !Other.IsA('UT_ShieldBelt')
						&& !Other.IsA('Seeds')
						&& !Other.IsA('SCUBAGear')
						&& !Other.IsA('JumpBoots')
						&& !Other.IsA('Health')
						&& !Other.IsA('Flare'))

////Rakiayn: determine what pickups are allowed in mm////

		{
			Inventory(Other).MyMarker.markedItem = None;
			return false;
		}
	}

		return Super.IsRelevant(Other);
}

function bool SetEndCams(string Reason)
{
	local TeamInfo Best;
	local MM_BaseQueen BestBase;
	local Pawn P;
	local int i;
	local PlayerPawn Player;

	for ( i=0; i<MaxTeams; i++ )
		if ( (Best == None) || (Best.Score < Teams[i].Score) )
			Best = Teams[i];

	for ( i=0; i<MaxTeams; i++ )
		if ( (Best.TeamIndex != i) && (Best.Score == Teams[i].Score) )
		{
			BroadcastLocalizedMessage(DMMessageClass, 0);
			return false;
		}		

	ForEach AllActors(class'MM_BaseQueen', BestBase)
		if ( BestBase.Team == Best.TeamIndex )
			break;

	GameReplicationInfo.GameEndedComments = TeamPrefix@Best.TeamName@GameEndedMessage;

	EndTime = Level.TimeSeconds + 3.0;
	for ( P=Level.PawnList; P!=None; P=P.nextPawn )
	{
		P.GotoState('GameEnded');
		Player = PlayerPawn(P);
		if ( Player != None )
		{
			Player.bBehindView = true;
			Player.ViewTarget = BestBase;
			if (!bTutorialGame)
				PlayWinMessage(Player, (Player.PlayerReplicationInfo.Team == Best.TeamIndex));
			Player.ClientGameEnded();
		}
	}
	BestBase.bHidden = false;
	CalcEndStats();
	return true;
}

function CalcEndStats()
{
	EndStatsClass.Default.TotalGames++;
	EndStatsClass.Static.StaticSaveConfig();
}

function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	if ( Other.IsA('translocator') )    // no translocator in Monster Match//
		return false;

}

function SendStartMessage(PlayerPawn P)
{
	P.ClearProgressMessages();
	P.SetProgressMessage(StartMessage, 0);
}

function ClearOrders(Pawn Leaving)
{
	local Pawn P;

	foreach AllActors (class'Pawn',P)

		if ( Bot(P) != None )
			if ( Bot(P).OrderObject != None && Bot(P).OrderObject == Leaving )
				Bot(P).SetOrders('Attack', None, True);
}

function PickAmbushSpotFor(Bot aBot)
{
	local NavigationPoint N;

	for ( N=Level.NavigationPointList; N!=None; N=N.NextNavigationPoint )
		if ( N.IsA('Ambushpoint') && !N.taken )
		{
			if ( aBot.Orders == 'Defend' )
			{
				if ( N.IsA('DefensePoint') && (DefensePoint(N).team == aBot.PlayerReplicationInfo.team) )
				{
					if ( (DefensePoint(aBot.Ambushspot) == None)
						|| (DefensePoint(N).priority > DefensePoint(aBot.Ambushspot).priority) )
						aBot.Ambushspot = Ambushpoint(N);
					else if ( (DefensePoint(N).priority == DefensePoint(aBot.Ambushspot).priority)
						&& (FRand() < 0.4) ) 
						aBot.Ambushspot = Ambushpoint(N);
				}		
				else if ( (DefensePoint(aBot.AmbushSpot) == None)
						&& (VSize(N.Location - aBot.OrderObject.Location) < 1500)
						&& FastTrace(aBot.OrderObject.Location, N.Location)
						&& ((aBot.Ambushspot == None) || (FRand() < 0.5)) )
							aBot.Ambushspot = Ambushpoint(N);
			}
			else if ( (aBot.AmbushSpot == None)
				|| (VSize(aBot.Location - aBot.Ambushspot.Location)
					 > VSize(aBot.Location - N.Location)) )
				aBot.Ambushspot = Ambushpoint(N);
		}
}

function bool NearANode(Bot aBot)
{
	local bool bIsNearby;
	local Pathnode P;

	bIsNearby = False;

	foreach aBot.RadiusActors( class 'Pathnode',P, 700 )
	{
		if ( P != None && FastTrace(aBot.Location,P.Location) )
		{
			bIsNearby = True;
			break;
		}
	}
	return bIsNearby;
}

function PlayStartUpMessage(PlayerPawn NewPlayer)
{
	local int i;
	local color WhiteColor;

	NewPlayer.ClearProgressMessages();

	// GameName
	NewPlayer.SetProgressMessage(GameName, i++);
	if ( bRequireReady && (Level.NetMode != NM_Standalone) )
		NewPlayer.SetProgressMessage(TourneyMessage, i++);
	else
		NewPlayer.SetProgressMessage(StartUpMessage, i++);

	if ( GoalTeamScore > 0 )
		NewPlayer.SetProgressMessage(GameGoal$int(GoalTeamScore), i++);

	if ( NewPlayer.PlayerReplicationInfo.Team < 4 )
	{
		NewPlayer.SetProgressColor(class'ChallengeTeamHUD'.Default.TeamColor[NewPlayer.PlayerReplicationInfo.Team], i);
		NewPlayer.SetProgressMessage(StartupTeamMessage@Teams[NewPlayer.PlayerReplicationInfo.Team].TeamName$StartupTeamTralier, i++);
		WhiteColor.R = 255;
		WhiteColor.G = 255;
		WhiteColor.B = 255;
		NewPlayer.SetProgressColor(WhiteColor, i);
		if ( !bRatedGame )
			NewPlayer.SetProgressMessage(TeamChangeMessage, i++);
	}

	if ( Level.NetMode == NM_Standalone )
		NewPlayer.SetProgressMessage(SingleWaitingMessage, i++);
}

defaultproperties
{
     bSpawnInTeamArea=True
     bScoreTeamKills=False
     bNoMonsters=False
     TimeLimit=60
     gamegoal="Team Score Limit: "
     GoalTeamScore=3.000000
     StartMessage="Monster Match has begun!"
     ScoreBoardType=Class'MMScoreBoard'
     HUDType=Class'MMHUD'
     MapListType=Class'MMMapList'
     MapPrefix="MM"
     BeaconName="MM"
     GameName="Monster Match"
     MutatorClass=Class'MM_Mutator'
     GameReplicationInfoClass=Class'MMGameReplicationInfo'
}
