class MMSBServerActor expands SpawnNotify;

var() config int ShowBonusInfo;
var() config bool ShowClickBoard;
var() config string CountryFlagsPackage;

var Decoration FakeFlag;
var Actor IpToCountry;

function bool BindIpToCountry()
{
	local Actor A;
	foreach AllActors(class'Actor', A, 'IpToCountry')
		IpToCountry = A;
}

function string GetIpInfo(string IP)
{
	if(IpToCountry != None)
		return IpToCountry.GetItemName(IP);
}

simulated event Spawned()
{
	if(Level.NetMode == NM_Client)
	{
		Spawn(Class'SDemoEnhacer');
	}
}

simulated event Actor SpawnNotification(actor A)
{
	local SPRI MPRI;

	if (A.IsA('Pawn') && !A.IsA('Spectator') && ShowBonusInfo>=0) //note to self: I put >=0 so it shows flags when bonusinfo=0
	{
		//log("Spawn MPRI");
		MPRI = Spawn(Class'SPRI', Pawn(A).PlayerReplicationInfo,, A.Location);
		MPRI.ShowBonusInfo = ShowBonusInfo;
		
		BindIpToCountry();
		
		if(IpToCountry != None)
		{
			MPRI.IpToCountry=IpToCountry;
			MPRI.CountryFlagsPackage=CountryFlagsPackage;
		}
	}

	return A;
}

defaultproperties
{
    ShowBonusInfo=2
    ShowClickBoard=True
    CountryFlagsPackage="CountryFlags2"
    ActorClass=Class'Engine.Pawn'
    Texture=None
}
