class MM_GiantManta expands MM_Manta;

State Patroling
{
     function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
                              Vector momentum, name damageType)
     {
          Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
          
          if(Enemy != None)
          {
               LastSeenPos = Enemy.Location;
               if (NextState == 'TakeHit')
               {
                    NextState = 'Attacking'; 
                    NextLabel = 'Begin';
                    GotoState('TakeHit');  
               }
               else if ( Enemy != None )
                    GotoState('Attacking');
          }
     }

     function SetFall()
     {
          NextState = 'Patroling'; 
          NextLabel = 'ResumePatrol';
          NextAnim = AnimSequence;
          GotoState('FallingState'); 
     }

     function HitWall(vector HitNormal, actor Wall)
     {
          if (Physics == PHYS_Falling)
               return;
          if ( Wall.IsA('Mover') && Mover(Wall).HandleDoor(self) )
          {
               if ( SpecialPause > 0 )
                    Acceleration = vect(0,0,0);
               GotoState('Patroling', 'SpecialNavig');
               return;
          }
          Focus = Destination;
          if (PickWallAdjust())
               GotoState('Patroling', 'AdjustFromWall');
          else
               MoveTimer = -1.0;
     }

     function Trigger( actor Other, pawn EventInstigator )
     {
          if ( bDelayedPatrol )
          {
               if ( bHateWhenTriggered )
               {
                    if ( EventInstigator.bIsPlayer)
                         AttitudeToPlayer = ATTITUDE_Hate;
                    else
                         Hated = EventInstigator;
               }
               GotoState('Patroling', 'Patrol');
          }
          else
               Global.Trigger(Other, EventInstigator);
     }
     
     function Timer()
     {
          Enable('Bump');
     }
     
     function AnimEnd()
     {
          PlayPatrolStop();
     }

     function EnemyAcquired()
     {
          //log(Class$" just acquired an enemy");
          GotoState('Acquisition');
     }

     function PickDestination()
     {
          local Actor path;
          
          path = None;
          if (SpecialGoal != None)
               path = FindPathToward(SpecialGoal);
          else if ( OrderObject != None )
               path = FindPathToward(OrderObject);
          if (path != None)
          {
               MoveTarget = path;
               Destination = path.Location;
          }
          else
               OrderObject = None;
     }

     function FindNextPatrol()
     {
          local PatrolPoint pat;
          if ( (PatrolPoint(OrderObject) != None) && (PatrolPoint(OrderObject).nextPatrol == OrderTag) )
               OrderObject = PatrolPoint(OrderObject).NextPatrolPoint;
          else
          {
               foreach AllActors( class 'Patrolpoint', pat, OrderTag )
               {
                    OrderObject = pat;
                    return;
               }
          }
     }

     function BeginState()
     {
          SpecialGoal = None;
          SpecialPause = 0.0;
          Enemy = None;
          NextAnim = '';
          Disable('AnimEnd');
          SetAlertness(0.0);
          bReadyToAttack = (FRand() < 0.3 + 0.2 * skill); 
     }


AdjustFromWall:
     StrafeTo(Destination, Focus); 
     Destination = Focus; 
     MoveTo(Destination);
     Goto('MoveToPatrol');

ResumePatrol:
     if (MoveTarget != None)
     {
          PlayWalking();
          MoveToward(MoveTarget, WalkingSpeed);
          Goto('ReachedPatrol');
     }
     else
          Goto('Patrol');
               
Begin:
     sleep(0.1);

Patrol: //FIXME -add stasis mode? - also set random start point in roam area
     WaitForLanding();
     FindNextPatrol();
     Disable('AnimEnd');
     if (PatrolPoint(OrderObject) != None)
     {
          ////log("Move to next patrol point");
          if ( !bQuiet && (FRand() < 0.4) )
               PlayRoamingSound();
          TweenToWalking(0.3);
          FinishAnim();
          PlayWalking();
          numHuntPaths = 0;

MoveToPatrol:
          if (actorReachable(OrderObject))
               MoveToward(OrderObject, WalkingSpeed);
          else
          {
               PickDestination();
               if (OrderObject != None)
               {
SpecialNavig:
                    if (SpecialPause > 0.0)
                    {
                         Acceleration = vect(0,0,0);
                         TweenToPatrolStop(0.3);
                         Sleep(SpecialPause);
                         SpecialPause = 0.0;
                         TweenToWalking(0.1);
                         FinishAnim();
                         PlayWalking();
                    }
                    numHuntPaths++;
                    MoveToward(MoveTarget, WalkingSpeed);
                    if ( numHuntPaths < 30 )
                         Goto('MoveToPatrol');
                    else
                         Goto('GiveUp');
               }
               else
                    Goto('GiveUp');
          }

ReachedPatrol:      
          ////log("Got to patrol point "$OrderTag);    
          OrderTag = Patrolpoint(OrderObject).Nextpatrol;
          ////log("Next patrol point "$OrderTag); 
          if ( Patrolpoint(OrderObject).pausetime > 0.0 )
          {
               ////log("Pause patrol");
               Acceleration = vect(0,0,0);
               TweenToFighter(0.2);
               FinishAnim();
               PlayTurning();
               TurnTo(Location + (Patrolpoint(OrderObject)).lookdir);
               if ( Patrolpoint(OrderObject).PatrolAnim != '')
               {
                    TweenAnim( Patrolpoint(OrderObject).PatrolAnim, 0.3);
                    FinishAnim();
                    Patrolpoint(OrderObject).AnimCount = Patrolpoint(OrderObject).numAnims;
                    While ( Patrolpoint(OrderObject).AnimCount > 0 )
                    {
                         Patrolpoint(OrderObject).AnimCount--;
                         if (Patrolpoint(OrderObject).PatrolSound != None )
                              PlaySound( Patrolpoint(OrderObject).PatrolSound ); 
                         PlayAnim(Patrolpoint(OrderObject).PatrolAnim);
                         FinishAnim();
                    }
               }
               else
               {
                    TweenToPatrolStop(0.3);
                    FinishAnim();
                    Enable('AnimEnd');
                    NextAnim = '';
                    PlayPatrolStop();
                    ////log("stop here for "$(Patrolpoint(OrderObject)).pausetime);
                    Sleep((Patrolpoint(OrderObject)).pausetime);
                    Disable('AnimEnd');
                    FinishAnim();
               }
          }
          Goto('Patrol');
     }

GiveUp:
          //log(self$" gave up patrol");
          Acceleration = vect(0,0,0);        
          TweenToPatrolStop(0.3);
          FinishAnim();
DelayedPatrol:
          Enable('AnimEnd');
          PlayPatrolStop();
}

state Guarding
{
     function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
                                   Vector momentum, name damageType)
     {
          Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
          if(Enemy != None)
          {
               LastSeenPos = Enemy.Location;
               if ( health <= 0 )
                    return;
               if (NextState == 'TakeHit')
               {
                    NextState = 'Attacking'; 
                    NextLabel = 'Begin';
                    GotoState('TakeHit'); 
               }
               else if ( Enemy != None )
                    GotoState('Attacking');
          }
     }
     
     function Timer()
     {
          Enable('Bump');
     }

     function EnemyAcquired()
     {
          GotoState('Acquisition');
     }
     
     function AnimEnd()
     {
          PlayPatrolStop();
     }

     function HitWall(vector HitNormal, actor Wall)
     {
          if (Physics == PHYS_Falling)
               return;
          if ( Wall.IsA('Mover') && Mover(Wall).HandleDoor(self) )
          {
               if ( SpecialPause > 0 )
                    Acceleration = vect(0,0,0);
               GotoState('Guarding', 'SpecialNavig');
               return;
          }
          Focus = Destination;
          if (PickWallAdjust())
               GotoState('Guarding', 'AdjustFromWall');
          else
               MoveTimer = -1.0;
     }
     
     function PickDestination()
     {
          local Actor path;
          
          path = None;
          if (SpecialGoal != None)
               path = FindPathToward(SpecialGoal);
          else if ( OrderObject != None )
               path = FindPathTo(OrderObject.Location);
          //log("Next path is "$path);
          if (path != None)
          {
               MoveTarget = path;
               Destination = path.Location;
          }
          else
               StartRoaming();
     }
     
     function SetFall()
     {
          NextState = 'Guarding'; 
          NextLabel = 'Begin';
          NextAnim = AnimSequence;
          GotoState('FallingState'); 
     }
     
     function BeginState()
     {
          SpecialGoal = None;
          SpecialPause = 0.0;
          Enemy = None;
          NextAnim = '';
          SetAlertness(0.0);
     }

AdjustFromWall:
     StrafeTo(Destination, Focus); 
     Destination = Focus; 
     MoveTo(Destination);
     Goto('GoToGuard');
     
Begin:
     //log(class$" guarding "$OrderObject);
     Disable('AnimEnd'); 

GoToGuard:
     if ( VSize(Location - OrderObject.Location) < 2 * CollisionRadius)
          Goto('Turn');
     TweenToRunning(0.2);
     FinishAnim();
     PlayRunning();
     WaitForLanding();
     if (actorReachable(OrderObject))
          MoveToward(OrderObject, FMax(0.75, WalkingSpeed)); 
     else
     {
          PickDestination();
SpecialNavig:
          if (SpecialPause > 0.0)
          {
               Acceleration = vect(0,0,0);
               TweenToPatrolStop(0.3);
               Sleep(SpecialPause);
               SpecialPause = 0.0;
               TweenToRunning(0.1);
               FinishAnim();
               PlayRunning();
          }              
          MoveToward(MoveTarget);
     }
     Goto('GoToGuard');
     
Turn:
     //log(class$" got to guardpoint");
     Acceleration = vect(0,0,0);
     TweenToFighter(0.3);
     FinishAnim();
     PlayTurning();
     TurnTo( Location + 1000 * vector(OrderObject.Rotation) );

     NextAnim = '';
     bReadyToAttack = false;
     TweenToPatrolStop(0.2);
     FinishAnim();
     Enable('AnimEnd');
     NextAnim = '';
     PlayPatrolStop();
     DesiredRotation = rot(0,0,0);
     DesiredRotation.Yaw = Rotation.Yaw;
     setRotation(DesiredRotation);
     if (Physics != PHYS_Falling) 
          SetPhysics(PHYS_None);
}

simulated event PostNetBeginPlay()
{
	super.PostNetBeginPlay();
	WetTexture'RedGiantManta'.Palette = Texture'DeepRed'.Palette;
	WetTexture'BlueGiantManta'.Palette = Texture'DeepBlue'.Palette;
}

function postbeginplay()
{
    local float Selection;
	
	WetTexture'RedGiantManta'.Palette = Texture'DeepRed'.Palette;
	WetTexture'BlueGiantManta'.Palette = Texture'DeepBlue'.Palette;
	
playerreplicationinfo.playername="Giant Manta";

	if ( Team == 3 )
	{
Selection = FRand();
if ( Selection < 1.0 )
	{
dropwhenkilled = (Class'mm_giantmantaammo');
	}
}
}

defaultproperties
{
     scorevalue=16
     StingDamage=40
     WhipDamage=40
     SightRadius=2000.000000
     Health=400
     CombatStyle=1.000000
     DrawScale=2.860000
     SoundRadius=18
     CollisionRadius=90.000000
     CollisionHeight=46.000000
     redteamskin=Texture'RedGiantManta'
     multiskinsredteam(1)=Texture'RedGiantManta'
     blueteamskin=Texture'BlueGiantManta'
     multiskinsblueteam(1)=Texture'BlueGiantManta'
}
