class MM_SkaarjBerserker expands SkaarjBerserker;

var() byte meleeteamvaluemonster;
var() byte Team;
var() config bool bHateOurOwn;
var() config bool bRespawn;
var MMMonsterStart startPoint;
var MonstermadnessMsgDelay msgDelayer;
var() config float RespawnDelay;
var() byte scorevalue;

var() texture redteamskin;
var() texture multiskinsredteam[8];
var() texture blueteamskin;
var() texture multiskinsblueteam[8];
var() texture zombieblueteamskin;
var() texture zombieredteamskin;
var() texture zombieskin;
var() texture meanzombieskin;

var() config bool bZombie;
var() config float zombiechance;

State Patroling
{
	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
						Vector momentum, name damageType)
	{
		Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
		
		if(Enemy != None)
		{
			LastSeenPos = Enemy.Location;
			if (NextState == 'TakeHit')
			{
				NextState = 'Attacking'; 
				NextLabel = 'Begin';
				GotoState('TakeHit');  
			}
			else if ( Enemy != None )
				GotoState('Attacking');
		}
	}

	function SetFall()
	{
		NextState = 'Patroling'; 
		NextLabel = 'ResumePatrol';
		NextAnim = AnimSequence;
		GotoState('FallingState'); 
	}

	function HitWall(vector HitNormal, actor Wall)
	{
		if (Physics == PHYS_Falling)
			return;
		if ( Wall.IsA('Mover') && Mover(Wall).HandleDoor(self) )
		{
			if ( SpecialPause > 0 )
				Acceleration = vect(0,0,0);
			GotoState('Patroling', 'SpecialNavig');
			return;
		}
		Focus = Destination;
		if (PickWallAdjust())
			GotoState('Patroling', 'AdjustFromWall');
		else
			MoveTimer = -1.0;
	}

	function Trigger( actor Other, pawn EventInstigator )
	{
		if ( bDelayedPatrol )
		{
			if ( bHateWhenTriggered )
			{
				if ( EventInstigator.bIsPlayer)
					AttitudeToPlayer = ATTITUDE_Hate;
				else
					Hated = EventInstigator;
			}
			GotoState('Patroling', 'Patrol');
		}
		else
			Global.Trigger(Other, EventInstigator);
	}
	
	function Timer()
	{
		Enable('Bump');
	}
	
	function AnimEnd()
	{
		PlayPatrolStop();
	}

	function EnemyAcquired()
	{
		//log(Class$" just acquired an enemy");
		GotoState('Acquisition');
	}

	function PickDestination()
	{
		local Actor path;
		
		path = None;
		if (SpecialGoal != None)
			path = FindPathToward(SpecialGoal);
		else if ( OrderObject != None )
			path = FindPathToward(OrderObject);
		if (path != None)
		{
			MoveTarget = path;
			Destination = path.Location;
		}
		else
			OrderObject = None;
	}

	function FindNextPatrol()
	{
		local PatrolPoint pat;
		if ( (PatrolPoint(OrderObject) != None) && (PatrolPoint(OrderObject).nextPatrol == OrderTag) )
			OrderObject = PatrolPoint(OrderObject).NextPatrolPoint;
		else
		{
			foreach AllActors( class 'Patrolpoint', pat, OrderTag )
			{
				OrderObject = pat;
				return;
			}
		}
	}

	function BeginState()
	{
		SpecialGoal = None;
		SpecialPause = 0.0;
		Enemy = None;
		NextAnim = '';
		Disable('AnimEnd');
		SetAlertness(0.0);
		bReadyToAttack = (FRand() < 0.3 + 0.2 * skill); 
	}


AdjustFromWall:
	StrafeTo(Destination, Focus); 
	Destination = Focus; 
	MoveTo(Destination);
	Goto('MoveToPatrol');

ResumePatrol:
	if (MoveTarget != None)
	{
		PlayWalking();
		MoveToward(MoveTarget, WalkingSpeed);
		Goto('ReachedPatrol');
	}
	else
		Goto('Patrol');
			
Begin:
	sleep(0.1);

Patrol: //FIXME -add stasis mode? - also set random start point in roam area
	WaitForLanding();
	FindNextPatrol();
	Disable('AnimEnd');
	if (PatrolPoint(OrderObject) != None)
	{
		////log("Move to next patrol point");
		if ( !bQuiet && (FRand() < 0.4) )
			PlayRoamingSound();
		TweenToWalking(0.3);
		FinishAnim();
		PlayWalking();
		numHuntPaths = 0;

MoveToPatrol:
		if (actorReachable(OrderObject))
			MoveToward(OrderObject, WalkingSpeed);
		else
		{
			PickDestination();
			if (OrderObject != None)
			{
SpecialNavig:
				if (SpecialPause > 0.0)
				{
					Acceleration = vect(0,0,0);
					TweenToPatrolStop(0.3);
					Sleep(SpecialPause);
					SpecialPause = 0.0;
					TweenToWalking(0.1);
					FinishAnim();
					PlayWalking();
				}
				numHuntPaths++;
				MoveToward(MoveTarget, WalkingSpeed);
				if ( numHuntPaths < 30 )
					Goto('MoveToPatrol');
				else
					Goto('GiveUp');
			}
			else
				Goto('GiveUp');
		}

ReachedPatrol:		
		////log("Got to patrol point "$OrderTag);	
		OrderTag = Patrolpoint(OrderObject).Nextpatrol;
		////log("Next patrol point "$OrderTag);	
		if ( Patrolpoint(OrderObject).pausetime > 0.0 )
		{
			////log("Pause patrol");
			Acceleration = vect(0,0,0);
			TweenToFighter(0.2);
			FinishAnim();
			PlayTurning();
			TurnTo(Location + (Patrolpoint(OrderObject)).lookdir);
			if ( Patrolpoint(OrderObject).PatrolAnim != '')
			{
				TweenAnim( Patrolpoint(OrderObject).PatrolAnim, 0.3);
				FinishAnim();
				Patrolpoint(OrderObject).AnimCount = Patrolpoint(OrderObject).numAnims;
				While ( Patrolpoint(OrderObject).AnimCount > 0 )
				{
					Patrolpoint(OrderObject).AnimCount--;
					if (Patrolpoint(OrderObject).PatrolSound != None )
						PlaySound( Patrolpoint(OrderObject).PatrolSound ); 
					PlayAnim(Patrolpoint(OrderObject).PatrolAnim);
					FinishAnim();
				}
			}
			else
			{
				TweenToPatrolStop(0.3);
				FinishAnim();
				Enable('AnimEnd');
				NextAnim = '';
				PlayPatrolStop();
				////log("stop here for "$(Patrolpoint(OrderObject)).pausetime);
				Sleep((Patrolpoint(OrderObject)).pausetime);
				Disable('AnimEnd');
				FinishAnim();
			}
		}
		Goto('Patrol');
	}

GiveUp:
		//log(self$" gave up patrol");
		Acceleration = vect(0,0,0);		
		TweenToPatrolStop(0.3);
		FinishAnim();
DelayedPatrol:
		Enable('AnimEnd');
		PlayPatrolStop();
}

state Guarding
{
	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
							Vector momentum, name damageType)
	{
		Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
		if(Enemy != None)
		{
			LastSeenPos = Enemy.Location;
			if ( health <= 0 )
				return;
			if (NextState == 'TakeHit')
			{
				NextState = 'Attacking'; 
				NextLabel = 'Begin';
				GotoState('TakeHit'); 
			}
			else if ( Enemy != None )
				GotoState('Attacking');
		}
	}
	
	function Timer()
	{
		Enable('Bump');
	}

	function EnemyAcquired()
	{
		GotoState('Acquisition');
	}
	
	function AnimEnd()
	{
		PlayPatrolStop();
	}

	function HitWall(vector HitNormal, actor Wall)
	{
		if (Physics == PHYS_Falling)
			return;
		if ( Wall.IsA('Mover') && Mover(Wall).HandleDoor(self) )
		{
			if ( SpecialPause > 0 )
				Acceleration = vect(0,0,0);
			GotoState('Guarding', 'SpecialNavig');
			return;
		}
		Focus = Destination;
		if (PickWallAdjust())
			GotoState('Guarding', 'AdjustFromWall');
		else
			MoveTimer = -1.0;
	}
	
	function PickDestination()
	{
		local Actor path;
		
		path = None;
		if (SpecialGoal != None)
			path = FindPathToward(SpecialGoal);
		else if ( OrderObject != None )
			path = FindPathTo(OrderObject.Location);
		//log("Next path is "$path);
		if (path != None)
		{
			MoveTarget = path;
			Destination = path.Location;
		}
		else
			StartRoaming();
	}
	
	function SetFall()
	{
		NextState = 'Guarding'; 
		NextLabel = 'Begin';
		NextAnim = AnimSequence;
		GotoState('FallingState'); 
	}
	
	function BeginState()
	{
		SpecialGoal = None;
		SpecialPause = 0.0;
		Enemy = None;
		NextAnim = '';
		SetAlertness(0.0);
	}

AdjustFromWall:
	StrafeTo(Destination, Focus); 
	Destination = Focus; 
	MoveTo(Destination);
	Goto('GoToGuard');
	
Begin:
	//log(class$" guarding "$OrderObject);
	Disable('AnimEnd');	

GoToGuard:
	if ( VSize(Location - OrderObject.Location) < 2 * CollisionRadius)
		Goto('Turn');
	TweenToRunning(0.2);
	FinishAnim();
	PlayRunning();
	WaitForLanding();
	if (actorReachable(OrderObject))
		MoveToward(OrderObject, FMax(0.75, WalkingSpeed)); 
	else
	{
		PickDestination();
SpecialNavig:
		if (SpecialPause > 0.0)
		{
			Acceleration = vect(0,0,0);
			TweenToPatrolStop(0.3);
			Sleep(SpecialPause);
			SpecialPause = 0.0;
			TweenToRunning(0.1);
			FinishAnim();
			PlayRunning();
		}			
		MoveToward(MoveTarget);
	}
	Goto('GoToGuard');
	
Turn:
	//log(class$" got to guardpoint");
	Acceleration = vect(0,0,0);
	TweenToFighter(0.3);
	FinishAnim();
	PlayTurning();
	TurnTo( Location + 1000 * vector(OrderObject.Rotation) );

	NextAnim = '';
	bReadyToAttack = false;
	TweenToPatrolStop(0.2);
	FinishAnim();
	Enable('AnimEnd');
	NextAnim = '';
	PlayPatrolStop();
	DesiredRotation = rot(0,0,0);
	DesiredRotation.Yaw = Rotation.Yaw;
	setRotation(DesiredRotation);
	if (Physics != PHYS_Falling) 
		SetPhysics(PHYS_None);
}

simulated event PostNetBeginPlay()
{
	super.PostNetBeginPlay();
	WetTexture'SkaarjBerserkerRed'.Palette = Texture'DeepRed'.Palette;
	WetTexture'SkaarjBerserkerBlue'.Palette = Texture'DeepBlue'.Palette;
}

function PreBeginPlay()
{
	local MM_Mutator dmtMutator;
	local bool bMutatorSpawned;
	local int iNameNumber;
	local string MyNewName;
	local float Selection;	

	bIsPlayer = true;
	Super.PreBeginPlay();

if (brespawn)

{
	startPoint = spawn(class'MMMonsterStart', self, , 
			Location, Rotation);
	if(startPoint == None)
	{
		Log(class$":PreBeginPlay : Couldn't spawn startPoint.");
	}
}
	bMutatorSpawned = false;
	foreach AllActors(class'MM_Mutator', dmtMutator)
	{
		bMutatorSpawned = true;
	}

	if(!bMutatorSpawned)
	{
		Log(class$":PreBeginPlay : Creating a MM_Mutator.");
		level.game.BaseMutator.AddMutator(Spawn(class'MM_Mutator'));
	}
meleeteamvaluemonster = team;

	if(Level.Game.IsA('TeamGamePlus'))
		PlayerReplicationInfo.Team = Team;
	else
		PlayerReplicationInfo.Team = 255;

	if ( Team == 0 )
	{
		multiSkins[0]=multiskinsredteam[0];
		multiSkins[1]=multiskinsredteam[1];
        multiSkins[2]=multiskinsredteam[2];
        multiSkins[3]=multiskinsredteam[3];
        multiSkins[4]=multiskinsredteam[4];	
		multiSkins[5]=multiskinsredteam[5];
        multiSkins[6]=multiskinsredteam[6];
        multiSkins[7]=multiskinsredteam[7];
        Skin=redteamskin;
	}
	if ( Team == 1 )
	{
		multiSkins[0]=multiskinsblueteam[0];
		multiSkins[1]=multiskinsblueteam[1];
        multiSkins[2]=multiskinsblueteam[2];
        multiSkins[3]=multiskinsblueteam[3];
        multiSkins[4]=multiskinsblueteam[4];	
		multiSkins[5]=multiskinsblueteam[5];
        multiSkins[6]=multiskinsblueteam[6];
        multiSkins[7]=multiskinsblueteam[7];
        Skin=blueteamskin;
	}
	if ( Team == 3 )

	{
	}
	SetInventory();
}
function postbeginplay()
{
    local float Selection;
	
	WetTexture'SkaarjBerserkerRed'.Palette = Texture'DeepRed'.Palette;
	WetTexture'SkaarjBerserkerBlue'.Palette = Texture'DeepBlue'.Palette;
	
playerreplicationinfo.playername="Skaarj Berserker";

	if ( Team == 3 )
	{
Selection = FRand();
if ( Selection < 1.0 )
	{
dropwhenkilled = (Class'mm_skaarjberserkerammo');
}
}
}
function bool IsPlayerNameBeingUsed(String strName)
{
	local PlayerReplicationInfo otherPRI;

	ForEach AllActors(class'PlayerReplicationInfo', otherPRI)
	{
		if(otherPRI != PlayerReplicationInfo &&
			otherPRI.PlayerName ~= strName)
		{
			return true;
		}
	}
	return false;
}

function Died(pawn Killer, name damageType, vector HitLocation)
{
	local string pawnName;
	Super.Died(Killer, damageType, HitLocation);
}

function Killed(pawn Killer, pawn Other, name damageType)
{
	if(self == Killer)
	{
	}
	Super.Killed(Killer, Other, damageType);
}

function bool RestartTitan( pawn aPlayer )	
{
	local bool foundStart;

	if( startPoint == None )
	{
		log(class$"::RestartPlayer : startPoint = None!");
		return false;
	}

	foundStart = aPlayer.SetLocation(startPoint.Location);
	if( foundStart )
	{
		startPoint.PlayTeleportEffect(aPlayer, true);
		aPlayer.SetRotation(startPoint.Rotation);
		aPlayer.ViewRotation = aPlayer.Rotation;
		aPlayer.Acceleration = vect(0,0,0);
		aPlayer.Velocity = vect(0,0,0);
		aPlayer.Health = aPlayer.Default.Health;
		aPlayer.SetCollision( true, true, true );
		aPlayer.ClientSetLocation( startPoint.Location, startPoint.Rotation );
		aPlayer.bHidden = false;
		aPlayer.DamageScaling = aPlayer.Default.DamageScaling;
		aPlayer.SoundDampening = aPlayer.Default.SoundDampening;
		SetInventory();
	}
	else
		log(startPoint$" Player start not useable!!!");

	return foundStart;
}

state Dying
{
ignores SeePlayer, EnemyNotVisible, HearNoise, Died, Bump, Trigger, HitWall, HeadZoneChange, FootZoneChange, ZoneChange, Falling, WarnTarget, LongFall, SetFall, PainTimer;

	function ReStartPlayer()
	{
		if( bHidden && RestartTitan(self) )
		{
			Velocity = vect(0,0,0);
			Acceleration = vect(0,0,0);
			ViewRotation = Rotation;
			SetPhysics(PHYS_Falling);
			GotoState('Roaming');
		}
		else if ( !IsInState('GameEnded') )
			GotoState('Dying', 'TryAgain');
	}

Begin:
	if ( Level.Game.bGameEnded )
		GotoState('GameEnded');
	Sleep(0.2);

	if(!bRespawn)
		GotoState('Destroying');

	if ( !bHidden )
		SpawnCarcass();
TryAgain:
	if ( !bHidden )
		HidePlayer();
	Sleep(RespawnDelay);
	ReStartPlayer();
	Goto('TryAgain');
WaitingForStart:
	bHidden = true;
}

State Destroying
{
ignores SeePlayer, EnemyNotVisible, HearNoise, KilledBy, Trigger, Bump, HitWall, HeadZoneChange, FootZoneChange, ZoneChange, Falling, WarnTarget, Died, LongFall, PainTimer;

	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
							Vector momentum, name damageType)
	{
		if ( bDeleteMe )
			return;
		Health = Health - Damage;
		Momentum = Momentum/Mass;
		AddVelocity( momentum ); 
		if ( !bHidden && Gibbed(damageType) )
		{
			bHidden = true;
			SpawnGibbedCarcass();
			if ( bIsPlayer )
				Destroy();
			else
				Destroy();
		}
	}

	function Timer()
	{
Destroy();
		if ( !bHidden )
		{
			bHidden = true;
			SpawnCarcass();
			if ( bIsPlayer )
				Destroy();
			else
				Destroy();
		}
	}

	event Landed(vector HitNormal)
	{
		SetPhysics(PHYS_None);
	}

	function BeginState()
	{
		SetTimer(0.3, false);
	}
}

state GameEnded
{
	ignores SeePlayer, HearNoise, KilledBy, Bump, HitWall, HeadZoneChange, FootZoneChange, ZoneChange, Falling, TakeDamage, WarnTarget, Died;

	function BeginState()
	{	
		local PlayerPawn pp;
		local UnrealScoreBoard usb;
		local String strWinner;

		if(msgDelayer != None)
			msgDelayer.bDisabled = true;

		if(Health >= 0)
		{
			//SetPhysics(PHYS_None);
			GotoState('Waiting', 'Begin');
		}
	}
}

function SetInventory()
{
	local Translator s;

	if ( FindInventoryType(class'Translator') != None )
		return;
	s = Spawn(class'Translator',,, Location);
	if (s != None)
	{
		s.bHeldItem = true;
		s.GiveTo( self );
	}

	if(inventory==None)
		Log(class$":SetInventory : No damn inventory!");
}

function bool SetEnemy( Pawn NewEnemy )
{
	local bool result;
	local eAttitude newAttitude, oldAttitude;
	local bool noOldEnemy;
	local float newStrength;

	if(NewEnemy.GetStateName() == 'PlayerWaiting')
	{
		return false;
	}

	if(PlayerReplicationInfo.Team != 255 &&
			PlayerReplicationInfo.Team == NewEnemy.PlayerReplicationInfo.Team)
	{
		return false;
	}

	if ( !bCanWalk && !bCanFly && !NewEnemy.FootRegion.Zone.bWaterZone )
		return false;
	if ( (NewEnemy == Self) || (NewEnemy == None) || (NewEnemy.Health <= 0) )
		return false;
	if ( (PlayerPawn(NewEnemy) == None) && 
		(ScriptedPawn(NewEnemy) == None) && 
		(Bots(NewEnemy) == None) &&
		(Bot(NewEnemy) == None))
		return false;

	noOldEnemy = (Enemy == None);
	result = false;
	newAttitude = AttitudeTo(NewEnemy);
	if ( !noOldEnemy )
	{
		if (Enemy == NewEnemy)
			return true;
		else if ( NewEnemy.bIsPlayer && (AlarmTag != '') )
		{
			OldEnemy = Enemy;
			Enemy = NewEnemy;
			result = true;
		} 
		else if ( newAttitude == ATTITUDE_Friendly )
		{
			if ( bIgnoreFriends )
				return false;
			if ( (NewEnemy.Enemy != None) && (NewEnemy.Enemy.Health > 0) ) 
			{
				if ( NewEnemy.Enemy.bIsPlayer && (NewEnemy.AttitudeToPlayer < AttitudeToPlayer) )
					AttitudeToPlayer = NewEnemy.AttitudeToPlayer;
				if ( AttitudeTo(NewEnemy.Enemy) < AttitudeTo(Enemy) )
				{
					OldEnemy = Enemy;
					Enemy = NewEnemy.Enemy;
					result = true;
				}
			}
		}
		else 
		{
			oldAttitude = AttitudeTo(Enemy);
			if ( (newAttitude < oldAttitude) || 
				( (newAttitude == oldAttitude) 
					&& ((VSize(NewEnemy.Location - Location) < VSize(Enemy.Location - Location)) 
						|| !LineOfSightTo(Enemy)) ) ) 
			{
				if ( bIsPlayer && Enemy.IsA('PlayerPawn') && !NewEnemy.IsA('PlayerPawn') )
				{
					newStrength = relativeStrength(NewEnemy);
					if ( (newStrength < 0.2) && (relativeStrength(Enemy) < FMin(0, newStrength))  
						&& (IsInState('Hunting')) && (Level.TimeSeconds - HuntStartTime < 5) )
						result = false;
					else
					{
						result = true;
						OldEnemy = Enemy;
						Enemy = NewEnemy;
					}
				} 
				else
				{
					result = true;
					OldEnemy = Enemy;
					Enemy = NewEnemy;
				}
			}
		}
	}
	else if ( newAttitude < ATTITUDE_Ignore )
	{
		result = true;
		Enemy = NewEnemy;
	}
	else if ( newAttitude == ATTITUDE_Friendly )
	{	
		if ( NewEnemy.bIsPlayer && (AlarmTag != '') )
		{
			Enemy = NewEnemy;
			result = true;
		} 
		if (bIgnoreFriends)
			return false;

		if ( (NewEnemy.Enemy != None) && (NewEnemy.Enemy.Health > 0) ) 
		{
			result = true;
			Enemy = NewEnemy.Enemy;
			if (Enemy.bIsPlayer)
				AttitudeToPlayer = ScriptedPawn(NewEnemy).AttitudeToPlayer;
			else if ( (ScriptedPawn(NewEnemy) != None) && (ScriptedPawn(NewEnemy).Hated == Enemy) )
				Hated = Enemy;
		}
	}

	if ( result )
	{
		LastSeenPos = Enemy.Location;
		LastSeeingPos = Location;
		EnemyAcquired();
		if ( !bFirstHatePlayer && Enemy.bIsPlayer && (FirstHatePlayerEvent != '') )
			TriggerFirstHate();
	}
	else if ( NewEnemy.bIsPlayer && (NewAttitude < ATTITUDE_Threaten) )
		OldEnemy = NewEnemy;
				
	return result;
}

function eAttitude AttitudeTo(Pawn Other)
{
	if(PlayerReplicationInfo.Team != 255 &&
			PlayerReplicationInfo.Team == Other.PlayerReplicationInfo.Team)
		return ATTITUDE_Friendly;

	if(bHateOurOwn && Other.class == class)
	{
		return ATTITUDE_Hate;
	}

	return Super.AttitudeTo(Other);
}

function BotVoiceMessage(name messagetype, byte MessageID, Pawn Sender)
{
	if ( messagetype == 'ORDER' )
	{
	}
}

function WhatToDoNext(name LikelyState, name LikelyLabel)
{
	local Pawn aPawn;

	aPawn = Level.PawnList;
	while ( aPawn != None )
	{
		if ( (aPawn.IsA('PlayerPawn') || aPawn.IsA('ScriptedPawn'))
			&& (VSize(Location - aPawn.Location) < 500)
			&& CanSee(aPawn) )
		{
			if ( SetEnemy(aPawn) )
			{
				GotoState('Attacking');
				return;
			}
		}
		aPawn = aPawn.nextPawn;
	}
	
	Super.WhatToDoNext(LikelyState, LikelyLabel);
}	

function eAttitude AttitudeToCreature(Pawn Other)
{
	if ( Other.IsA('ScriptedPawn') && !Other.IsA('SkaarjWarrior') )
		return ATTITUDE_Hate;
	else
		return ATTITUDE_Hate;
}

function SpinDamageTarget()
{
local meleeattack s;

PlaySound(slice, SLOT_Interact);
s =	spawn(class'meleeattack',,,);
s.meleeteamvalue = self.meleeteamvaluemonster;
s.instigator = self.instigator;
s.lifespan = 0.3;
if (self.team == 0)    
s.damage = self.spindamage*s.damagepercenatage; 
else            
s.damage = self.spindamage*s.damagepercenatage;	
}

function ClawDamageTarget()
{

local meleeattack s;

PlaySound(slice, SLOT_Interact);
s =	spawn(class'meleeattack',,,);
s.meleeteamvalue = self.meleeteamvaluemonster;
s.instigator = self.instigator;
s.lifespan = 0.3;
if (self.team == 0)    
s.damage = self.clawdamage*s.damagepercenatage; 
else            
s.damage = self.clawdamage*s.damagepercenatage;
}
	function LungeDamageTarget()
{

local meleeattack s;

s =	spawn(class'meleeattack',,,);
s.meleeteamvalue = self.meleeteamvaluemonster;
s.instigator = self.instigator;
s.lifespan = 0.3;
AttackSuccess = true;
disable('Bump');
PlaySound(Slice, SLOT_Interact);

if (self.team == 0)    
s.damage = self.lungedamage*s.damagepercenatage; 
else            
s.damage = self.lungedamage*s.damagepercenatage;		
}

function Carcass SpawnCarcass()
{
   local carcass carc;
   local inventory w;
   local inventory v;
   local MM_SkaarjBerserker s;
   local float Selection;

   Selection = FRand();
   if ( self.instigator != None )
   {
      w = instigator.FindInventoryType(class'MM_GoldUnholyTool');
   if ( w != None )  
   {
      if  ( Selection < zombiechance )
      {
         if (!bzombie) 
         {
            s = Spawn(class'MM_SkaarjBerserker',,,Location);
            if ( s != None )
            {
               s.instigator = self.instigator;
               if ( s.PlayerReplicationInfo != None && self.PlayerReplicationInfo != None )
                  s.playerreplicationinfo.team = self.playerreplicationinfo.team;
               s.aggressiveness = self.aggressiveness * 2;
               s.bhasrangedattack = false;
               s.bmovingrangedattack = false;
               s.bcanstrafe = false;
               s.dropwhenkilled = none;
               s.drawscale = self.drawscale;
               s.bzombie = true;
               v = instigator.FindInventoryType(class'MM_SilverImprovementTool');
               if ( v != None ) 
               {
                  s.groundspeed =0.7*self.groundspeed;
                  s.airspeed = 0.7*self.airspeed;
                  s.waterspeed = 2.5*self.waterspeed;
                  s.health = self.default.health*3;
                  s.fatness = 0.3*self.fatness;
               }
               v = instigator.FindInventoryType(class'MM_SilverImprovementTool');
               if ( v == None )
               {
                  s.groundspeed =0.5*self.groundspeed;
                  s.airspeed = 0.5*self.airspeed;
                  s.waterspeed = 2*self.waterspeed;
                  s.health = self.default.health*2;
                  s.fatness = 0.5*self.fatness;
               }
               s.skin = zombieskin;
               s.multiskins[0] = self.zombieskin;
               s.multiskins[1] = self.zombieskin;
               s.multiskins[2] = self.zombieskin;
               s.multiskins[3] = self.zombieskin;
               s.multiskins[4] = self.zombieskin;
               s.multiskins[5] = self.zombieskin;
               s.multiskins[6] = self.zombieskin;
               s.multiskins[7] = self.zombieskin;
            }
         }
         else
		//if (bzombie) //Can be just an else !bzombie was before Boolean has only 2 options !bzombie or else is automated bzombie
         {
            carc = Spawn(CarcassType);
            if ( carc != None )
            {
               carc.multiskins[0] = self.multiskins[0]; 
               carc.multiskins[1] = self.multiskins[1]; 
               carc.multiskins[2] = self.multiskins[2]; 
               carc.multiskins[3] = self.multiskins[3]; 
               carc.multiskins[4] = self.multiskins[4]; 
               carc.multiskins[5] = self.multiskins[5]; 
               carc.multiskins[6] = self.multiskins[6]; 
               carc.multiskins[7] = self.multiskins[7]; 
               carc.skin = self.skin; 
               carc.fatness = self.fatness;
			   //if ( carc != None )
               carc.Initfor(self);
            }
         }
      }
      else
      {
         carc = Spawn(CarcassType);
         if (carc != None)
         {
         carc.multiskins[0] = self.multiskins[0]; 
         carc.multiskins[1] = self.multiskins[1]; 
         carc.multiskins[2] = self.multiskins[2]; 
         carc.multiskins[3] = self.multiskins[3]; 
         carc.multiskins[4] = self.multiskins[4]; 
         carc.multiskins[5] = self.multiskins[5]; 
         carc.multiskins[6] = self.multiskins[6]; 
         carc.multiskins[7] = self.multiskins[7]; 
         carc.skin = self.skin; 
         carc.fatness = self.fatness;
		 //if ( carc != None )
         carc.Initfor(self);
         }
      }
   }
   //w = instigator.FindInventoryType(class'MM_GoldUnholyTool');
   else  
   {
      carc = Spawn(CarcassType);
      if ( carc != None )
      {
         carc.multiskins[0] = self.multiskins[0]; 
         carc.multiskins[1] = self.multiskins[1]; 
         carc.multiskins[2] = self.multiskins[2]; 
         carc.multiskins[3] = self.multiskins[3]; 
         carc.multiskins[4] = self.multiskins[4]; 
         carc.multiskins[5] = self.multiskins[5]; 
         carc.multiskins[6] = self.multiskins[6]; 
         carc.multiskins[7] = self.multiskins[7]; 
         carc.skin = self.skin;
         carc.fatness = self.fatness; 
		 //if ( carc != None )
         carc.Initfor(self);
      }
   }
}
   return carc;
}

defaultproperties
{
     meleeteamvaluemonster=255
     Team=3
     scorevalue=23
     redteamskin=Texture'SkaarjBerserkerRed'
     multiskinsredteam(1)=Texture'SkaarjBerserkerRed'
     blueteamskin=Texture'SkaarjBerserkerBlue'
     multiskinsblueteam(1)=Texture'SkaarjBerserkerBlue'
     zombieskin=Texture'UnrealShare.Skins.Jmta1'
     meanzombieskin=Texture'UnrealShare.Effects.PalGreen'
     RangedProjectile=Class'MM_SkaarjProjectile'
}
