//=============================================================================
// MMSpawnerProjectileB.
//=============================================================================
class MM_SpawnerProjectileB expands Projectile;

var scriptedpawn myscriptedpawn;

var() texture SpriteAnim[6];
var int i;
var() int ownerteamprojectile;			//Rakiayn: Added this line//

var() sound    redSpawnSound;		// Sound made when projectile is spawned.
var() sound    blueSpawnSound;		// Sound made when projectile is spawned.
var() sound    greenSpawnSound;		// Sound made when projectile is spawned.
var() float sleeptime;              //Rakiayn: the amount of time before the projectile explodes//

var() texture team0projectileskin;
var() texture team1projectileskin;
var() texture team2projectileskin;
var() texture team3projectileskin;


function SetUp()
{
	if ( ScriptedPawn(Instigator) != None )
		Speed = ScriptedPawn(Instigator).ProjectileSpeed;
	Velocity = Vector(Rotation) * speed;
	MakeNoise ( 1.0 );
	
}

	simulated function BeginState()
	{

		SetTimer(0.2, false);
		SetUp();

		if ( Level.NetMode != NM_DedicatedServer )
		{
			LoopAnim('All',1.0);
			if ( Level.NetMode == NM_Standalone )
				SoundPitch = 200 + 50 * FRand();
		}			
	}




///////////
//////////


simulated function Timer()
{
	Texture = SpriteAnim[i];
	i++;
	if (i>=6) i=0;
}





simulated function PostBeginPlay()
{
	SetUp();
	if ( Level.NetMode != NM_DedicatedServer )
	{
		Texture = SpriteAnim[0];
		i=1;
		SetTimer(5.0,True);
	}
	Super.PostBeginPlay();
}

auto state Flying
{


simulated function ProcessTouch (Actor Other, Vector HitLocation)
{
	if (Other != instigator)
	{
		if ( Role == ROLE_Authority )
			Other.TakeDamage(Damage, instigator,HitLocation,
					15000.0 * Normal(velocity), 'burned');
		Explode(HitLocation, Vect(0,0,0));
	}
}

function Explode(vector HitLocation, vector HitNormal)
{

                                                                            ////////////////////////////////////////
                                                                            ///Rakiayn: monstertype is added here///
local mm_lesserbrute s;                                                     ////////////////////////////////////////   
 

local vector X,Y,Z, projStart; //test//




	if ( (Role == ROLE_Authority) && (FRand() < 0.5) )
		MakeNoise(1.0); //FIXME - set appropriate loudness



	                                                                         ////////////////////////////////////////
s =  Spawn(class'mm_lesserbrute',,,HitLocation+HitNormal*9);                 ///Rakiayn: monstertype is added here///

if (s != None)
{

if (self.ownerteamprojectile == 0)
{

    Spawn(class'RedMonsterSpawnEffect',,,HitLocation+HitNormal*9);
 

    PlaySound(redspawnSound);
    s.playerreplicationinfo.team = self.ownerteamprojectile;
    s.instigator = self.instigator;  //Rakiayn: this line is part of the connection between the monster and the player who summoned it//
	//s.RemoteRole = ROLE_None;//
    s.dropwhenkilled = none;   // monster drops ammo//	
//////////////////////////////
    s.skin = s.redteamskin; 
    s.multiskins[0] = s.multiskinsredteam[0];
    s.multiskins[1] = s.multiskinsredteam[1];
    s.multiskins[2] = s.multiskinsredteam[2];
    s.multiskins[3] = s.multiskinsredteam[3];
    s.multiskins[4] = s.multiskinsredteam[4];
    s.multiskins[5] = s.multiskinsredteam[5];
    s.multiskins[4] = s.multiskinsredteam[6];
    s.multiskins[5] = s.multiskinsredteam[7];
//////////////////////////////
    Destroy();

}
if (self.ownerteamprojectile == 1)
{
	 
    Spawn(class'BlueMonsterSpawnEffect',,,HitLocation+HitNormal*9);

    PlaySound(bluespawnSound);
    s.playerreplicationinfo.team = self.ownerteamprojectile;
    s.instigator = self.instigator;  //Rakiayn: this line is part of the connection between the monster and the player who summoned it//
	//s.RemoteRole = ROLE_None;//
    s.dropwhenkilled = none;   // monster drops ammo//	
//////////////////////////////
    s.skin = s.blueteamskin; 
    s.multiskins[0] = s.multiskinsblueteam[0];
    s.multiskins[1] = s.multiskinsblueteam[1];
    s.multiskins[2] = s.multiskinsblueteam[2];
    s.multiskins[3] = s.multiskinsblueteam[3];
    s.multiskins[4] = s.multiskinsblueteam[4];
    s.multiskins[5] = s.multiskinsblueteam[5];
    s.multiskins[6] = s.multiskinsblueteam[6];
    s.multiskins[7] = s.multiskinsblueteam[7];
//////////////////////////////
    Destroy();
}
if (self.ownerteamprojectile == 2)
{
	  
    Spawn(class'GreenMonsterSpawnEffect',,,HitLocation+HitNormal*9);

    PlaySound(greenspawnSound);
    s.playerreplicationinfo.team = self.ownerteamprojectile;
    s.instigator = self.instigator;  //Rakiayn: this line is part of the connection between the monster and the player who summoned it//
	//s.RemoteRole = ROLE_None;//
    s.dropwhenkilled = none;   // monster drops ammo//	
    Destroy();
}
if (self.ownerteamprojectile == 3)
{

    spawn(class'GoldMonsterSpawnEffect',,,HitLocation+HitNormal*9);

    PlaySound(greenspawnSound);
    s.playerreplicationinfo.team = self.ownerteamprojectile;
    s.instigator = self.instigator;  //Rakiayn: this line is part of the connection between the monster and the player who summoned it//
	//s.RemoteRole = ROLE_None;//
    s.dropwhenkilled = (Class'mm_lesserbruteammo');   // monster drops ammo//	
    Destroy();
    
}
Destroy();
}
}

Begin:

 




if (self.ownerteamprojectile == 0)
{
multiskins[0]=team0projectileskin;	
multiskins[1]=team0projectileskin;
multiskins[2]=team0projectileskin;
multiskins[3]=team0projectileskin;	
multiskins[4]=team0projectileskin;
multiskins[5]=team0projectileskin;
multiskins[6]=team0projectileskin;
multiskins[7]=team0projectileskin;


Skin=team0projectileskin;
texture=team0projectileskin;
}
if (self.ownerteamprojectile == 1)
{
multiskins[0]=team1projectileskin;
multiskins[1]=team1projectileskin;
multiskins[2]=team1projectileskin;
multiskins[3]=team1projectileskin;
multiskins[4]=team1projectileskin;
multiskins[5]=team1projectileskin;
multiskins[6]=team1projectileskin;
multiskins[7]=team1projectileskin;


Skin=team1projectileskin;
texture=team1projectileskin;
}

if (self.ownerteamprojectile == 2)
{
multiskins[0]=team2projectileskin;
multiskins[1]=team2projectileskin;
multiskins[2]=team2projectileskin;
multiskins[3]=team2projectileskin;
multiskins[4]=team2projectileskin;
multiskins[5]=team2projectileskin;
multiskins[6]=team2projectileskin;
multiskins[7]=team2projectileskin;

Skin=team2projectileskin;
texture=team2projectileskin;
}
if (self.ownerteamprojectile == 3)
{
multiskins[0]=team3projectileskin;
multiskins[1]=team3projectileskin;
multiskins[2]=team3projectileskin;
multiskins[3]=team3projectileskin;
multiskins[4]=team3projectileskin;
multiskins[5]=team3projectileskin;
multiskins[6]=team3projectileskin;
multiskins[7]=team3projectileskin;

Skin=team3projectileskin;
texture=team3projectileskin;
}




	Sleep(sleeptime);
	Explode(Location, Vect(0,0,0));

}

defaultproperties
{
     SpriteAnim(0)=FireTexture'UnrealShare.Effect1.FireEffect1a'
     SpriteAnim(1)=FireTexture'UnrealShare.Effect1.FireEffect1a'
     SpriteAnim(2)=FireTexture'UnrealShare.Effect1.FireEffect1a'
     SpriteAnim(3)=FireTexture'UnrealShare.Effect1.FireEffect1a'
     SpriteAnim(4)=FireTexture'UnrealShare.Effect1.FireEffect1a'
     SpriteAnim(5)=FireTexture'UnrealShare.Effect1.FireEffect1a'
     ownerteamprojectile=255
     redSpawnSound=Sound'UnrealShare.Generic.RespawnSound'
     blueSpawnSound=Sound'UnrealShare.Generic.RespawnSound'
     greenSpawnSound=Sound'UnrealShare.Generic.RespawnSound'
     sleeptime=1.500000
     team0projectileskin=FireTexture'FireEffectRed'
     team1projectileskin=FireTexture'UnrealShare.Effect1.FireEffect1u'
     team2projectileskin=FireTexture'UnrealShare.Effect1.FireEffect1a'
     team3projectileskin=FireTexture'UnrealShare.Effect1.FireEffect1e'
     Damage=100.000000
     SpawnSound=Sound'UnrealShare.Generic.RespawnSound'
     ImpactSound=Sound'UnrealShare.Generic.RespawnSound'
     bNetTemporary=False
     RemoteRole=ROLE_SimulatedProxy
     Physics=PHYS_Falling
     Style=STY_Translucent
     Texture=None
     DrawScale=0.500000
     ScaleGlow=3.000000
     AmbientGlow=128
     bUnlit=True
     MultiSkins(0)=FireTexture'UnrealShare.Effect7.MyTex16'
     MultiSkins(1)=FireTexture'UnrealShare.Effect7.MyTex16'
     MultiSkins(2)=FireTexture'UnrealShare.Effect7.MyTex16'
     MultiSkins(3)=FireTexture'UnrealShare.Effect7.MyTex16'
     MultiSkins(4)=FireTexture'UnrealShare.Effect7.MyTex16'
     MultiSkins(5)=FireTexture'UnrealShare.Effect7.MyTex16'
     MultiSkins(6)=FireTexture'UnrealShare.Effect7.MyTex16'
     MultiSkins(7)=FireTexture'UnrealShare.Effect7.MyTex16'
     CollisionRadius=140.000000
     CollisionHeight=40.000000
     bBlockActors=True
     bBlockPlayers=True
}
