class MMHUD extends ChallengeTeamHUD;

#exec TEXTURE IMPORT FILE=Textures\Icons\TQueenBlue.pcx GROUP=Skins FLAGS=2
#exec TEXTURE IMPORT FILE=Textures\Icons\TQueenRed.pcx GROUP=Skins FLAGS=2

var Pawn IdentifyPawn;
var bool bMonsterStats;
var bool bEnforceHealth;
var() localized string RedTeam, BlueTeam, MMIdentifyName, IdentifyHealth;
var TournamentGameReplicationInfo OwnerGame;

exec function MonsterStats()
{
	bMonsterStats = !bMonsterStats;
}

simulated function DrawGameSynopsis(Canvas Canvas)
{
	local float XL, YL, XOffset, YOffset;
	local int i, Time, eff;

	OwnerGame = TournamentGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);

	Canvas.Font = MyFonts.GetHugeFont( Canvas.ClipX );

	//////////////////////
	// Draw Team Score ///
	//////////////////////
	Canvas.StrLen(OwnerGame.Teams[0].Score, XL, YL);
	Canvas.SetPos(Canvas.ClipX - 64 * Scale, Canvas.ClipY - (236 + 128) * Scale);
	Canvas.DrawColor = TeamColor[0];
	Canvas.DrawIcon(texture'TQueenRed', Scale);
	Canvas.SetPos(Canvas.ClipX - 90 * Scale, Canvas.ClipY - (220 + 128) * Scale);
	Canvas.DrawText(int(OwnerGame.Teams[0].Score), False);

	Canvas.StrLen(OwnerGame.Teams[1].Score, XL, YL);
	Canvas.DrawColor = TeamColor[1];
	Canvas.SetPos(Canvas.ClipX - 64 * Scale, Canvas.ClipY - (336 + 128) * Scale);
	Canvas.DrawIcon(texture'TQueenBlue', Scale);
	Canvas.SetPos(Canvas.ClipX - 90 * Scale, Canvas.ClipY - (320 + 128) * Scale);
	Canvas.DrawText(int(OwnerGame.Teams[1].Score), False);
}

simulated function bool TraceIdentify(canvas Canvas)
{
	local Actor         other;
	local vector        hitLocation,
                        hitNormal,
                        startTrace,
                        endTrace;

	startTrace = Owner.Location;
	startTrace.Z += PawnOwner.BaseEyeHeight;
	endTrace = startTrace + vector(PawnOwner.ViewRotation) * 10000.0;
	other = Trace(hitLocation, hitNormal, endTrace, startTrace, true);

	if ( Pawn(other) != None && !other.bHidden )
	{
		IdentifyTarget = Pawn(other).PlayerReplicationInfo;
		IdentifyPawn = Pawn(other);
		IdentifyFadeTime = 3.0;
	}

	if ( IdentifyFadeTime == 0 || IdentifyPawn == None ||
      (IdentifyTarget != None && IdentifyTarget.bFeigningDeath) )
		return false;
		
	if ( (MMPRI(IdentifyTarget) != none) && MMPRI(IdentifyTarget).bHideIdentify )
		return false;

	return true;
}

simulated function SetIDColor(canvas Canvas, int type)
{
    local int team;

    if ( IdentifyTarget != None )
        team = IdentifyTarget.Team;

    if ( type == 0 )
		Canvas.DrawColor = AltTeamColor[team] * 0.333 *
          IdentifyFadeTime;
	else
    	Canvas.DrawColor = TeamColor[team] * 0.333 *
          IdentifyFadeTime;
}

simulated function bool DrawIdentifyInfo(canvas Canvas)
{
	local MMPlayerData MMData;
	local float l,buildTime;
	local PlayerReplicationInfo PRI;
	local GameInfo gi;
	local ScriptedPawn SP;

	if ( bMonsterStats || !TraceIdentify(Canvas) )
		return false;

	if( ScriptedPawn(IdentifyPawn) != None )
	{
		if ( IdentifyPawn.bDeleteMe )
			return false;
			
		SP = ScriptedPawn(IdentifyPawn);

		Canvas.Font = MyFonts.GetBigFont(Canvas.ClipX);
		DrawTwoColorID(Canvas,MMIdentifyName,SP.MenuName,Canvas.ClipY - 260 * Scale);

				if(IdentifyPawn.PlayerReplicationInfo.Team == Pawn(Owner).PlayerReplicationInfo.Team)
		   		{
					Canvas.Font = MyFonts.GetSmallFont(Canvas.ClipX);
					DrawTwoColorID(Canvas,IdentifyHealth,string(IdentifyPawn.Health)	,Canvas.ClipY - 230 * Scale);
		   		}
	}

		if ( (IdentifyTarget != None) && (IdentifyTarget.PlayerName != "") && (IdentifyPawn != none) )
		{
			if ( bEnforceHealth )
			{	ForEach IdentifyPawn.ChildActors (class'MMPlayerData', MMData)
				{
					MMData.SetHealth();
					break;
				}
			}
			Canvas.Font = MyFonts.GetBigFont(Canvas.ClipX);
			DrawTwoColorID(Canvas,MMIdentifyName, IdentifyTarget.PlayerName, Canvas.ClipY - 260 * Scale);

				if(IdentifyPawn.PlayerReplicationInfo.Team == Pawn(Owner).PlayerReplicationInfo.Team)
		   		{
					Canvas.Font = MyFonts.GetSmallFont(Canvas.ClipX);
					DrawTwoColorID(Canvas,IdentifyHealth,string(IdentifyPawn.Health)	,Canvas.ClipY - 230 * Scale);
		   		}
	 }
}

defaultproperties
{
     MMIdentifyName="Name:"
     IdentifyHealth="Health:"
}
