class MM_Spawner expands TournamentWeapon;

#exec TEXTURE IMPORT FILE=Textures\Icons\UseFly.pcx GROUP="Icons"
#exec TEXTURE IMPORT FILE=Textures\Icons\UsePupae.pcx GROUP="Icons"
#exec TEXTURE IMPORT FILE=Textures\Icons\UseManta.pcx GROUP="Icons"
#exec TEXTURE IMPORT FILE=Textures\Icons\UseGiantManta.pcx GROUP="Icons"
#exec TEXTURE IMPORT FILE=Textures\Icons\UseLesserBrute.pcx GROUP="Icons"
#exec TEXTURE IMPORT FILE=Textures\Icons\UseSlith.pcx GROUP="Icons"
#exec TEXTURE IMPORT FILE=Textures\Icons\UseKrall.pcx GROUP="Icons"
#exec TEXTURE IMPORT FILE=Textures\Icons\UseBrute.pcx GROUP="Icons"
#exec TEXTURE IMPORT FILE=Textures\Icons\UseBehemoth.pcx GROUP="Icons"
#exec TEXTURE IMPORT FILE=Textures\Icons\UseMerc.pcx GROUP="Icons"
#exec TEXTURE IMPORT FILE=Textures\Icons\UseMercElite.pcx GROUP="Icons"
#exec TEXTURE IMPORT FILE=Textures\Icons\UseSkWar.pcx GROUP="Icons"
#exec TEXTURE IMPORT FILE=Textures\Icons\UseSkBer.pcx GROUP="Icons"
#exec TEXTURE IMPORT FILE=Textures\Icons\UseGasbag.pcx GROUP="Icons"
#exec TEXTURE IMPORT FILE=Textures\Icons\UseGiantGasbag.pcx GROUP="Icons"
#exec TEXTURE IMPORT FILE=Textures\Icons\UseQueen.pcx GROUP="Icons"
#exec TEXTURE IMPORT FILE=Textures\Icons\UseWarlord.pcx GROUP="Icons"

var() int ammocost;
var() float rechargingtime;
var() texture Bluespawnerskin;
var() texture Redspawnerskin;
var() texture Greenspawnerskin;
var() texture Goldspawnerskin;

simulated function PlayIdleAnim()
{
	if ( Mesh == PickupViewMesh )
		return;
	if ( (Owner != None) && (VSize(Owner.Velocity) > 10) )
		PlayAnim('Walking',0.3,0.3);
	else 
		TweenAnim('Still', 1.0);
	Enable('AnimEnd');
}

function Projectile ProjectileFire(class<projectile> ProjClass, float ProjSpeed, bool bWarn)
{
local Vector Start, X,Y,Z;

	Owner.MakeNoise(Pawn(Owner).SoundDampening);
	GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
	Start = Owner.Location + CalcDrawOffset() + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z; 
	AdjustedAim = pawn(owner).AdjustAim(ProjSpeed, Start, AimError, True, bWarn);	
	return Spawn(ProjClass,,, Start,AdjustedAim);
}

simulated function PlayFiring()
{
	PlayAnim( 'Fire', 0.9, 0.05);
	PlayOwnedSound(FireSound, SLOT_None, Pawn(Owner).SoundDampening);
}

simulated function bool ClientFire( float Value )
{
	if ( bCanClientFire && ((Role == ROLE_Authority) || (AmmoType == None) || (AmmoType.AmmoAmount > ammocost)) )
	{
		if ( (PlayerPawn(Owner) != None) 
			&& ((Level.NetMode == NM_Standalone) || PlayerPawn(Owner).Player.IsA('ViewPort')) )
		{
			if ( InstFlash != 0.0 )
				PlayerPawn(Owner).ClientInstantFlash( InstFlash, InstFog);
			PlayerPawn(Owner).ShakeView(ShakeTime, ShakeMag, ShakeVert);
		}
		if ( Affector != None )
			Affector.FireEffect();
		PlayFiring();
		if ( Role < ROLE_Authority )
			GotoState('ClientFiring');
		return true;
	}
	if( AmmoType == None )
	{
		return true;
	}
	if( AmmoType.AmmoAmount < ammocost )
	{
		return true;
	}
	return false;
}		

function Fire( float Value )

{
	local class<projectile> Proj;
	local mm_spawnerprojectile q;
	local Vector Start, X,Y,Z;
	local Bot B;
	local Pawn P;
	local inventory w;  

 w = instigator.FindInventoryType(class'MM_BronzeMonsterCreditTool');
   	if ( w != None )  

    {	       
self.ammocost = self.default.ammocost *0.9;  
     }

	if ( (AmmoType == None) && (AmmoName != None) )
	{
	}
	if ( AmmoType.UseAmmo(ammocost) )
	{
		bCanClientFire = true;
		bPointing=True;
		Start = Owner.Location + CalcDrawOffset();
		B = Bot(Owner);
		P = Pawn(Owner);
		P.PlayRecoil(FiringSpeed);
		Owner.MakeNoise(2.0 * P.SoundDampening);
		AdjustedAim = P.AdjustAim(AltProjectileSpeed, Start, AimError, True, bWarnTarget);
		GetAxes(AdjustedAim,X,Y,Z);
		//Spawn(class'WeaponLight',,'',Start+X*20,rot(0,0,0));
		Start = Start + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z;

		ClientFire(Value);
		GotoState('NormalFire');

		if ( bRapidFire || (FiringSpeed > 0) )
			Pawn(Owner).PlayRecoil(FiringSpeed);
		if ( bInstantHit )
			TraceFire(0.0);
		else
{

if (projectileclass == class'mm_spawnerprojectile')
{                   
		q = spawn(class'mm_spawnerprojectile',, '', Start, AdjustedAim);
        q.instigator = pawn(owner).instigator;
}
if (projectileclass == class'MM_flyspawnprojectile')
{                                                                  
		q = spawn(class'MM_flyspawnprojectile',, '', Start, AdjustedAim);
        q.instigator = pawn(owner).instigator;
}
if (projectileclass == class'MM_pupaespawnprojectile')
{
		q = spawn(class'MM_pupaespawnprojectile',, '', Start, AdjustedAim);
        q.instigator = pawn(owner).instigator;
}
if (projectileclass == class'MM_mantaspawnprojectile')
{
		q = spawn(class'MM_mantaspawnprojectile',, '', Start, AdjustedAim);
        q.instigator = pawn(owner).instigator;
}
if (projectileclass == class'MM_Giantmantaspawnprojectile')
{
		q = spawn(class'MM_Giantmantaspawnprojectile',, '', Start, AdjustedAim);
        q.instigator = pawn(owner).instigator;
}
if (projectileclass == class'MM_krallspawnprojectile')
{
		q = spawn(class'MM_krallspawnprojectile',, '', Start, AdjustedAim);
        q.instigator = pawn(owner).instigator;
}
if (projectileclass == class'MM_slithspawnprojectile')
{
		q = spawn(class'MM_slithspawnprojectile',, '', Start, AdjustedAim);
        q.instigator = pawn(owner).instigator;
}
if (projectileclass == class'MM_lesserbrutespawnprojectile')
{
		q = spawn(class'MM_lesserbrutespawnprojectile',, '', Start, AdjustedAim);
        q.instigator = pawn(owner).instigator;
}
if (projectileclass == class'MM_brutespawnprojectile')
{
		q = spawn(class'MM_brutespawnprojectile',, '', Start, AdjustedAim);
        q.instigator = pawn(owner).instigator;
}
if (projectileclass == class'MM_mercenaryspawnprojectile')
{
		q = spawn(class'MM_mercenaryspawnprojectile',, '', Start, AdjustedAim);
        q.instigator = pawn(owner).instigator;
}
if (projectileclass == class'MM_mercenaryelitespawnprojectile')
{
		q = spawn(class'MM_mercenaryelitespawnprojectile',, '', Start, AdjustedAim);
        q.instigator = pawn(owner).instigator;
}
if (projectileclass == class'MM_behemothspawnprojectile')
{
		q = spawn(class'MM_behemothspawnprojectile',, '', Start, AdjustedAim);
        q.instigator = pawn(owner).instigator;
}
if (projectileclass == class'MM_skaarjwarriorspawnprojectile')
{
		q = spawn(class'MM_skaarjwarriorspawnprojectile',, '', Start, AdjustedAim);
        q.instigator = pawn(owner).instigator;
}
if (projectileclass == class'MM_skaarjberserkerspawnprojectile')
{
		q = spawn(class'MM_skaarjberserkerspawnprojectile',, '', Start, AdjustedAim);
        q.instigator = pawn(owner).instigator;
}
if (projectileclass == class'MM_gasbagspawnprojectile')
{
		q = spawn(class'MM_gasbagspawnprojectile',, '', Start, AdjustedAim);
        q.instigator = pawn(owner).instigator;
}
if (projectileclass == class'MM_giantgasbagspawnprojectile')
{
		q = spawn(class'MM_giantgasbagspawnprojectile',, '', Start, AdjustedAim);
        q.instigator = pawn(owner).instigator;
}
if (projectileclass == class'MM_warlordspawnprojectile')
{
		q = spawn(class'MM_warlordspawnprojectile',, '', Start, AdjustedAim);
        q.instigator = pawn(owner).instigator;
}
if (projectileclass == class'MM_queenspawnprojectile')
{
		q = spawn(class'MM_queenspawnprojectile',, '', Start, AdjustedAim);
        q.instigator = pawn(owner).instigator;
}
if (projectileclass == class'mm_giveammoprojectile')
{
		q = spawn(class'mm_giveammoprojectile',, '', Start, AdjustedAim);
        q.instigator = pawn(owner).instigator;
}

if (pawn(owner).playerreplicationinfo.team == 0)
{
q.SpriteAnim[0]=q.redprojectileskin;	
q.SpriteAnim[1]=q.redprojectileskin;
q.SpriteAnim[2]=q.redprojectileskin;
q.SpriteAnim[3]=q.redprojectileskin;	
q.SpriteAnim[4]=q.redprojectileskin;
q.SpriteAnim[5]=q.redprojectileskin;
q.Skin=q.redprojectileskin;
q.texture=q.redprojectileskin;
}
if (pawn(owner).playerreplicationinfo.team == 1)
{
q.SpriteAnim[0]=q.Blueprojectileskin;
q.SpriteAnim[1]=q.Blueprojectileskin;
q.SpriteAnim[2]=q.Blueprojectileskin;
q.SpriteAnim[3]=q.Blueprojectileskin;      
q.SpriteAnim[4]=q.Blueprojectileskin;
q.SpriteAnim[5]=q.Blueprojectileskin;
q.Skin=q.Blueprojectileskin;
q.texture=q.Blueprojectileskin;	
}
if (pawn(owner).playerreplicationinfo.team == 2)
{
q.SpriteAnim[0]=q.Greenprojectileskin;
q.SpriteAnim[1]=q.Greenprojectileskin;
q.SpriteAnim[2]=q.Greenprojectileskin;
q.SpriteAnim[3]=q.Greenprojectileskin;      
q.SpriteAnim[4]=q.Greenprojectileskin;
q.SpriteAnim[5]=q.Greenprojectileskin;
q.Skin=q.Greenprojectileskin;
q.texture=q.Greenprojectileskin;	
}
if (pawn(owner).playerreplicationinfo.team == 3)
{
q.SpriteAnim[0]=q.Goldprojectileskin;
q.SpriteAnim[1]=q.Goldprojectileskin;
q.SpriteAnim[2]=q.Goldprojectileskin;
q.SpriteAnim[3]=q.Goldprojectileskin;      
q.SpriteAnim[4]=q.Goldprojectileskin;
q.SpriteAnim[5]=q.Goldprojectileskin;
q.Skin=q.Goldprojectileskin;
q.texture=q.Goldprojectileskin;	
}

q.ownerteamprojectile = pawn(owner).playerreplicationinfo.team;

}
}
}

function float RateSelf( out int bUseAltMode )
{
	local float Selection;	
	local Pawn P;
	if ( AmmoType.AmmoAmount >=ammocost )
{
Selection = FRand();

if ( Selection < 0.5 )
  {
		return +2 +(ammocost*0.01);
  }
else
  {
		return +1 +(ammocost*0.01);
  }
}

	if ( AmmoType.AmmoAmount >=ammocost )
{
		return  -2 -(ammocost*0.01);
}
	P = Pawn(Owner);
	if ( (P.Enemy == None ) || (P.Enemy.Location.Z < Owner.Location.Z - 60) || (FRand() < 0.5) )
		bUseAltMode = 1;
	else 
		bUseAltMode = 0;

	if ( P.Enemy != None )
	{
		if ( Owner.Location.Z > P.Enemy.Location.Z + 140 )
		{
			bUseAltMode = 1;
			return (AIRating + 0.25);
		}
		else if ( P.Enemy.Location.Z > Owner.Location.Z + 160 )
			return (AIRating - 0.07);
	}
	return (AIRating + FRand() * 0.05);
}

function AltFire( float Value )

 {
    local class<projectile> Proj;
    local mm_spawnerprojectile qa;

    local Vector Start, X,Y,Z;
	local Bot B;
	local Pawn P;
    local inventory w;  

 w = instigator.FindInventoryType(class'MM_BronzeMonsterCreditTool');
   	if ( w != None )  

    {	       
self.ammocost = self.default.ammocost *0.9;  
     }

	if ( AmmoType == None )
	{
	}
	if (AmmoType.UseAmmo(ammocost))
	{
		bCanClientFire = true;
		bPointing=True;
		Start = Owner.Location + CalcDrawOffset();
		B = Bot(Owner);
		P = Pawn(Owner);
		P.PlayRecoil(FiringSpeed);
		Owner.MakeNoise(2.0 * P.SoundDampening);
		AdjustedAim = P.AdjustAim(AltProjectileSpeed, Start, AimError, True, bWarnTarget);
		GetAxes(AdjustedAim,X,Y,Z);
		//Spawn(class'WeaponLight',,'',Start+X*20,rot(0,0,0));
		Start = Start + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z;

		ClientFire(Value);
		GotoState('NormalFire');

		if ( bRapidFire || (FiringSpeed > 0) )
			Pawn(Owner).PlayRecoil(FiringSpeed);
		if ( bInstantHit )
			TraceFire(0.0);
		else
{

if (altprojectileclass == class'mm_spawnerprojectilealt')
{
		qa = spawn(class'mm_spawnerprojectilealt',, '', Start, AdjustedAim);
        qa.instigator = pawn(owner).instigator;
}
if (altprojectileclass == class'MM_flyspawnprojectilealt')
{
		qa = spawn(class'MM_flyspawnprojectilealt',, '', Start, AdjustedAim);
        qa.instigator = pawn(owner).instigator;
}
if (altprojectileclass == class'MM_pupaespawnprojectilealt')
{
		qa = spawn(class'MM_pupaespawnprojectilealt',, '', Start, AdjustedAim);
        qa.instigator = pawn(owner).instigator;
}
if (altprojectileclass == class'MM_mantaspawnprojectilealt')
{
		qa = spawn(class'MM_mantaspawnprojectilealt',, '', Start, AdjustedAim);
        qa.instigator = pawn(owner).instigator;
}
if (altprojectileclass == class'MM_Giantmantaspawnprojectilealt')
{
		qa = spawn(class'MM_Giantmantaspawnprojectilealt',, '', Start, AdjustedAim);
        qa.instigator = pawn(owner).instigator;
}
if (altprojectileclass == class'MM_krallspawnprojectilealt')
{
		qa = spawn(class'MM_krallspawnprojectilealt',, '', Start, AdjustedAim);
        qa.instigator = pawn(owner).instigator;
}
if (altprojectileclass == class'MM_slithspawnprojectilealt')
{
		qa = spawn(class'MM_slithspawnprojectilealt',, '', Start, AdjustedAim);
        qa.instigator = pawn(owner).instigator;
}
if (altprojectileclass == class'MM_lesserbrutespawnprojectilealt')
{
		qa = spawn(class'MM_lesserbrutespawnprojectilealt',, '', Start, AdjustedAim);
        qa.instigator = pawn(owner).instigator;
}
if (altprojectileclass == class'MM_brutespawnprojectilealt')
{
		qa = spawn(class'MM_brutespawnprojectilealt',, '', Start, AdjustedAim);
        qa.instigator = pawn(owner).instigator;
}
if (altprojectileclass == class'MM_behemothspawnprojectilealt')
{
		qa = spawn(class'MM_behemothspawnprojectilealt',, '', Start, AdjustedAim);
        qa.instigator = pawn(owner).instigator;
}
if (altprojectileclass == class'MM_skaarjwarriorspawnprojectilealt')
{
		qa = spawn(class'MM_skaarjwarriorspawnprojectilealt',, '', Start, AdjustedAim);
        qa.instigator = pawn(owner).instigator;
}
if (altprojectileclass == class'MM_skaarjberserkerspawnprojectilealt')
{
		qa = spawn(class'MM_skaarjberserkerspawnprojectilealt',, '', Start, AdjustedAim);
        qa.instigator = pawn(owner).instigator;
}
if (altprojectileclass == class'MM_gasbagspawnprojectilealt')
{
		qa = spawn(class'MM_gasbagspawnprojectilealt',, '', Start, AdjustedAim);
        qa.instigator = pawn(owner).instigator;
}
if (altprojectileclass == class'MM_giantgasbagspawnprojectilealt')
{
		qa = spawn(class'MM_giantgasbagspawnprojectilealt',, '', Start, AdjustedAim);
        qa.instigator = pawn(owner).instigator;
}
if (altprojectileclass == class'MM_warlordspawnprojectilealt')
{
		qa = spawn(class'MM_warlordspawnprojectilealt',, '', Start, AdjustedAim);
        qa.instigator = pawn(owner).instigator;
}
if (altprojectileclass == class'MM_queenspawnprojectilealt')
{
		qa = spawn(class'MM_queenspawnprojectilealt',, '', Start, AdjustedAim);
        qa.instigator = pawn(owner).instigator;
}
if (altprojectileclass == class'MM_mercenaryspawnprojectilealt')
{
		qa = spawn(class'MM_mercenaryspawnprojectilealt',, '', Start, AdjustedAim);
        qa.instigator = pawn(owner).instigator;
}
if (altprojectileclass == class'MM_mercenaryelitespawnprojectilealt')
{
		qa = spawn(class'MM_mercenaryelitespawnprojectilealt',, '', Start, AdjustedAim);
        qa.instigator = pawn(owner).instigator;
}

if (projectileclass == class'mm_giveammoprojectile')
{
		qa = spawn(class'mm_giveammoprojectile',, '', Start, AdjustedAim);
        qa.instigator = pawn(owner).instigator;
}

if (pawn(owner).playerreplicationinfo.team == 0)
{
qa.SpriteAnim[0]=qa.redprojectileskin;	
qa.SpriteAnim[1]=qa.redprojectileskin;
qa.SpriteAnim[2]=qa.redprojectileskin;
qa.SpriteAnim[3]=qa.redprojectileskin;	
qa.SpriteAnim[4]=qa.redprojectileskin;
qa.SpriteAnim[5]=qa.redprojectileskin;
qa.Skin=qa.redprojectileskin;
qa.texture=qa.redprojectileskin;
}
if (pawn(owner).playerreplicationinfo.team == 1)
{
qa.SpriteAnim[0]=qa.Blueprojectileskin;
qa.SpriteAnim[1]=qa.Blueprojectileskin;
qa.SpriteAnim[2]=qa.Blueprojectileskin;
qa.SpriteAnim[3]=qa.Blueprojectileskin;      
qa.SpriteAnim[4]=qa.Blueprojectileskin;
qa.SpriteAnim[5]=qa.Blueprojectileskin;
qa.Skin=qa.Blueprojectileskin;
qa.texture=qa.Blueprojectileskin;	
}
if (pawn(owner).playerreplicationinfo.team == 2)
{
qa.SpriteAnim[0]=qa.Greenprojectileskin;
qa.SpriteAnim[1]=qa.Greenprojectileskin;
qa.SpriteAnim[2]=qa.Greenprojectileskin;
qa.SpriteAnim[3]=qa.Greenprojectileskin;      
qa.SpriteAnim[4]=qa.Greenprojectileskin;
qa.SpriteAnim[5]=qa.Greenprojectileskin;
qa.Skin=qa.Greenprojectileskin;
qa.texture=qa.Greenprojectileskin;	
}
if (pawn(owner).playerreplicationinfo.team == 3)
{
qa.SpriteAnim[0]=qa.Goldprojectileskin;
qa.SpriteAnim[1]=qa.Goldprojectileskin;
qa.SpriteAnim[2]=qa.Goldprojectileskin;
qa.SpriteAnim[3]=qa.Goldprojectileskin;      
qa.SpriteAnim[4]=qa.Goldprojectileskin;
qa.SpriteAnim[5]=qa.Goldprojectileskin;
qa.Skin=qa.Goldprojectileskin;
qa.texture=qa.Goldprojectileskin;	
}
}

qa.ownerteamprojectile = pawn(owner).playerreplicationinfo.team;
	
}
}

simulated function bool ClientAltFire( float Value )
{
	if ( bCanClientFire && ((Role == ROLE_Authority) || (AmmoType == None) || (AmmoType.AmmoAmount > ammocost)) )
	{
		if ( (PlayerPawn(Owner) != None) 
			&& ((Level.NetMode == NM_Standalone) || PlayerPawn(Owner).Player.IsA('ViewPort')) )
		{
			if ( InstFlash != 0.0 )
				PlayerPawn(Owner).ClientInstantFlash( InstFlash, InstFog);
			PlayerPawn(Owner).ShakeView(ShakeTime, ShakeMag, ShakeVert);
		}
		if ( Affector != None )
			Affector.FireEffect();
		PlayFiring();
		if ( Role < ROLE_Authority )
			GotoState('ClientFiring');
		return true;
	}
	if( AmmoType == None )
	{
		return true;
	}
	if( AmmoType.AmmoAmount < ammocost )
	{
		return true;
	}
	return false;
}


simulated function PlayAltFiring()
{
	PlayAnim( 'Fire', 0.9, 0.05);
	PlayOwnedSound(AltFireSound, SLOT_None, Pawn(Owner).SoundDampening);
}

function float SuggestAttackStyle()
{
	return -0.2;
}

function float SuggestDefenseStyle()
{
	return -0.2;
}

state ClientReload
{
	simulated function bool ClientFire(float Value)
	{
		bForceFire = bForceFire || ( bCanClientFire && (Pawn(Owner) != None) && (AmmoType.AmmoAmount > 0) );
		return bForceFire;
	}

	simulated function bool ClientAltFire(float Value)
	{
		bForceAltFire = bForceAltFire || ( bCanClientFire && (Pawn(Owner) != None) && (AmmoType.AmmoAmount > 0) );
		return bForceAltFire;
	}

	simulated function AnimEnd()
	{
		if ( bCanClientFire && (PlayerPawn(Owner) != None) && (AmmoType.AmmoAmount > 0) )
		{
			if ( bForceFire || (Pawn(Owner).bFire != 0) )
			{
				Global.ClientFire(0);
				return;
			}
			else if ( bForceAltFire || (Pawn(Owner).bAltFire != 0) )
			{
				Global.ClientAltFire(0);
				return;
			}
		}			
		GotoState('');
		Global.AnimEnd();
	}

	simulated function EndState()
	{
		bForceFire = false;
		bForceAltFire = false;
	}

	simulated function BeginState()
	{
		bForceFire = false;
		bForceAltFire = false;
	}
}

state ClientFiring
{
	simulated function AnimEnd()
	{
		if ( (Pawn(Owner) == None) || (Ammotype.AmmoAmount <= 0) )
		{
			PlayIdleAnim();
			GotoState('');
		}
		else if ( !bCanClientFire )
			GotoState('');
		else
		{
			PlayReloading();
			GotoState('ClientReload');
		}
	}
}

state ClientAltFiring
{
	simulated function AnimEnd()
	{
		if ( (Pawn(Owner) == None) || (Ammotype.AmmoAmount <= 0) )
		{
			PlayIdleAnim();
			GotoState('');
		}
		else if ( !bCanClientFire )
			GotoState('');
		else
		{
			PlayReloading();
			GotoState('ClientReload');
		}

	}
}

state NormalFire
{
	function AnimEnd()
	{
		if ( (AnimSequence != 'Charging') && (AmmoType.AmmoAmount > 0) )
			PlayReloading();
		else
			Finish();
	}
}

simulated function PlayReloading()
{
	LoopAnim( 'charging', rechargingtime + 0.05 * FireAdjust, 0.05 );
	//Owner.PlaySound(CockingSound, SLOT_Misc, 1.7*Pawn(Owner).SoundDampening,,,fMax(0.5,1.35-rechargingtime/8.0) );
}

function Finish()
{
	local Pawn PawnOwner;
	local bool bForce, bForceAlt;

	bForce = bForceFire;
	bForceAlt = bForceAltFire;
	bForceFire = false;
	bForceAltFire = false;

	if ( bChangeWeapon )
	{
		GotoState('DownWeapon');
		return;
	}

	PawnOwner = Pawn(Owner);
	if ( PawnOwner == None )
		return;
	if ( PlayerPawn(Owner) == None )
	{
		if ( (AmmoType != None) && (AmmoType.AmmoAmount<=0) )
		{
			PawnOwner.StopFiring();
			PawnOwner.SwitchToBestWeapon();
			if ( bChangeWeapon )
				GotoState('DownWeapon');
		}
		else if ( (PawnOwner.bFire != 0) && (FRand() < RefireRate) )
			Global.Fire(0);
		else if ( (PawnOwner.bAltFire != 0) && (FRand() < AltRefireRate) )
			Global.AltFire(0);	
		else 
		{
			PawnOwner.StopFiring();
			GotoState('Idle');
        }
		return;
	}
	
	if ( ((AmmoType != None) && (AmmoType.AmmoAmount<=0)) || (PawnOwner.Weapon != self) )
		GotoState('Idle');

	else if ( (PawnOwner.bFire!=0) || bForce )
		Global.Fire(0);
	else if ( (PawnOwner.bAltFire!=0) || bForceAlt )
		Global.AltFire(0);
	else 
		GotoState('Idle');
		Owner.PlaySound(Sound'UnrealShare.Pickups.TransA3', SLOT_Misc, Pawn(Owner).SoundDampening);
}

simulated function PlaySelect()
{
local Pawn P;
	P = Pawn(Owner);
	bForceFire = false;
	bForceAltFire = false;
	bCanClientFire = false;
	if ( !IsAnimating() || (AnimSequence != 'Select') )
	PlayAnim('Select',1.0,0.0);

if (Pawn(Owner).PlayerReplicationInfo.Team==0 )        
{
multiskins[0]=redspawnerskin;
multiskins[1]=redspawnerskin;
multiskins[2]=redspawnerskin;
multiskins[3]=redspawnerskin;
multiskins[4]=redspawnerskin;
multiskins[5]=redspawnerskin;
multiskins[6]=redspawnerskin;
}
if (Pawn(Owner).PlayerReplicationInfo.Team==1 )
{
multiskins[0]=bluespawnerskin;
multiskins[1]=bluespawnerskin;
multiskins[2]=bluespawnerskin;
multiskins[3]=bluespawnerskin;
multiskins[4]=bluespawnerskin;
multiskins[5]=bluespawnerskin;
multiskins[6]=bluespawnerskin;
}
if (Pawn(Owner).PlayerReplicationInfo.Team==2 )
{
multiskins[0]=greenspawnerskin;
multiskins[1]=greenspawnerskin;
multiskins[2]=greenspawnerskin;
multiskins[3]=greenspawnerskin;
multiskins[4]=greenspawnerskin;
multiskins[5]=greenspawnerskin;
multiskins[6]=greenspawnerskin;
}
if (Pawn(Owner).PlayerReplicationInfo.Team==3 )
{
multiskins[0]=goldspawnerskin;
multiskins[1]=goldspawnerskin;
multiskins[2]=goldspawnerskin;
multiskins[3]=goldspawnerskin;
multiskins[4]=goldspawnerskin;
multiskins[5]=goldspawnerskin;
multiskins[6]=goldspawnerskin;
}
}

defaultproperties
{
     ammocost=1
     rechargingtime=0.900000
     Bluespawnerskin=Texture'BlueMonsterSpawner'
     Redspawnerskin=Texture'RedMonsterSpawner'
     Greenspawnerskin=Texture'GreenMonsterSpawner'
     Goldspawnerskin=Texture'MMSpawner'
     AmmoName=Class'MMGame_v1_1.MM_Credit'
     PickupAmmoCount=5
     bSplashDamage=True
     bCanThrow=False
     bRecommendAltSplashDamage=True
     FireOffset=(X=20.000000,Y=-9.000000,Z=-10.000000)
     ProjectileClass=Class'MMGame_v1_1.MM_SpawnerProjectile'
     AltProjectileClass=Class'MMGame_v1_1.MM_SpawnerProjectileAlt'
     AIRating=0.500000
     RefireRate=1.000000
     AltRefireRate=1.000000
     FireSound=Sound'UnrealI.Cannon.CannonShot'
     AltFireSound=Sound'UnrealI.Cannon.CannonShot'
     CockingSound=Sound'UnrealI.BioRifle.GelLoad'
     DeathMessage="%o was killed by %k's Monster."
     PlayerViewOffset=(X=1.850000,Y=-0.700000,Z=-1.150000)
     PlayerViewMesh=LodMesh'UnrealI.BRifle'
     BobDamping=0.975000
     PickupViewMesh=LodMesh'UnrealI.BRiflePick'
     ThirdPersonMesh=LodMesh'UnrealI.BRifle3'
     StatusIcon=Texture'Botpack.Icons.UseRazor'
     PickupSound=Sound'UnrealShare.Pickups.WeaponPickup'
     Icon=LodMesh'UnrealI.BRiflePick'
     Mesh=LodMesh'UnrealI.BRiflePick'
     bNoSmooth=False
     CollisionRadius=28.000000
     CollisionHeight=15.000000
}
